#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
/**/
#include	"ksysprot.h"
#include    "kawkfunc.h"
/**/
/*EXTERNAL*/
/**/
lineretr()          /* return line number */
{
    return(linenum);
}
linesetr(ln)        /* set line number */
NOSIGN	ln;
{
    return(linenum = ln);
}
char    *
lpxsetr(is)         /* set line pointer */
char    *is;
{
    return(lpx = is);
}
char    *
lpxretr()           /* return line pointer */
{
    return(lpx);
}
char	*
lneprt(is,os)   /* write line of text */
char    *is;    /* label if any */
char    *os;    /* string */
{
	auto	char	*eot;
    if(!isnull(is)) printf("%10.10s: ",is);
	if((int)(eot = index(os,LF)))	*eot = ZERO;
	funxesc(os,stdout);
	return(NULL);
}
char    *
errptr(is,os)   /* draw line to error */
char    *is;    /* current parse position */
char    *os;    /* error message */
{
    auto    char    *ax;
    auto    char    *bx;
    auto    char    *lpx = lpxretr();
    lneprt("",lpx);
    if(lpx > is)    {
        is = lpx;
        errmsg("errptr <cannot point to error>\n");
        }
    for(ax = lpx, bx = is; ax < bx; ax++)
        if(*ax == '\t') {
                fputs("@I",stdout);
        }
        else    fputc('_',stdout);
    fputc('|',stdout);
    fputc('\n',stdout);
    fflush(stdout);
    /**/
    errmsg("%s\n",os);
    terror(FUBAR);
    return(NULL);
}
char    *
skipbs(is)          /* skip blanks; increment line count */
char    *is;
{
    register    char    *isx = is;
    register    int     comment = 0;
    if(!is) dump("skipbs: is");
    while(*isx != ZERO)
    switch(*isx)    {
/*  old form comment */
    case    '#':    while(*isx != ZERO && *isx != '\n') ++isx;
                    break;
    case    '*':    if(isx[1] == '/')   {
                        comment -= 1;
                        if(comment < 0) {
                            errptr(isx,"skipbs <nested comment>");
                            terror(FUBAR);
                            }
                        isx += 2;
                        continue;
                        }
                    if(comment) isx += 1;
                    else        return(isx);
                    break;
    case    '/':    if(isx[1] == '*')   {
                        comment += 1;
                        if(comment > 1) {
                            errptr(isx,"skipbs <nested comment>");
                            }
                        isx += 2;
                        continue;
                        }
                    if(comment) isx += 1;
                    else        return(isx);
                    break;
    case    ' ':    isx += 1;
                    break;
    case    '\t':   isx += 1;
                    break;
    case    '\n':   linenum += 1;
                    if(kenv.tracer) {
                        addcode(xlinenum,"xlinenum");
                        addcode((INST) linenum,"linenum");
                        }
                    lpx = lpxsetr(isx += 1);
                    break;
    default:        if(comment == 0)    return(isx);
                    else
                    if(*isx < 0 || *isx > '~')  {
                        errptr(isx,"skipbs <non-ascii char>");
                        }
                    else                isx += 1;
                    break;
    }
    return(isx);
}
