#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
#include	"ksysprot.h"
#include	"kawkfunc.h"
/**/
void
kinfile(na,ap)      /* return input file name */
int     na;
DATUM   *ap;
{
    if(na == 0) rdx.v.ptr = cfn;
    else
    if(na == 1) rdx.v.ptr = infile(ap[0].v.ivalu);
    pusher = spush;
}
void
kcount(na,ap)       /* return input record count */
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = count;
    pusher = ipush;
}
void
kfilenum(na,ap)     /* return current file number */
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = cfile;
    pusher = ipush;
}
void
kfseek(na,ap)
int     na;
DATUM   *ap;
{
	auto	FILE	*fp;
	auto	long	ad = (long) ap[1].v.dvalu;
	auto	int		po = ap[2].v.ivalu;
	if(ap[0].v.ivalu == 0)	fp = ifp;
	else
	if(ap[0].v.ivalu == 1)	fp = ofp;
	else					fp = (FILE *) ap[0].v.ivalu;
    rdx.v.ivalu = efseek(fp,ad,po);
    pusher = ipush;
}
void
kaccess(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = access(ap[0].v.ptr,ap[1].v.ivalu);
    pusher = ipush;
}
void
klink(na,ap)
int     na;
DATUM   *ap;
{
	auto	char	*src = ap[0].v.ptr;
	auto	char	*tar = ap[1].v.ptr;
	rdx.v.ivalu = link(src,tar);
	if(rdx.v.ivalu)	{
		prterr("link(%s,%s)",src,tar);
		}
    pusher = ipush;
}
void
kunlink(na,ap)
int na;
DATUM   *ap;
{
	auto	char	*src = ap[0].v.ptr;
    rdx.v.ivalu = unlink(src);
	if(rdx.v.ivalu)	{
		prterr("unlink(%s)",src);
		}
    pusher = ipush;
}
void
kfilemod(na,ap)
int na;
DATUM   *ap;
{
    rdx.v.ptr = filemod(ap[0].v.ptr);
    pusher = spush;
}
void
kfilesize(na,ap)
int na;
DATUM   *ap;
{
	auto	long	fs;
    fs = filesize(ap[0].v.ptr);
	if(fs <= 0L)	rdx.v.ivalu = (int) fs;
	else	{
		fs += (long) BLKSIZ - (fs % (long) BLKSIZ);
		fs /= (long) BLKSIZ;
		rdx.v.ivalu = (int) fs;
		}
    pusher = ipush;
}
void
kgetcwd(na,ap)
int     na;
DATUM   *ap;
{
	rdx.v.ptr = getcwd(ap[0].v.ptr,ap[1].v.ivalu);
    pusher = spush;
}
void
kkchdir(na,ap)
int   na;
DATUM   *ap;
{
    if(na == 0)	{
		rdx.v.ivalu = kchdir(NULL);
		}
	else
	if(na == 1)	{
		rdx.v.ivalu = kchdir(ap[0].v.ptr);
		}
    pusher = ipush;
}
void
krewind(na,ap)
int     na;
DATUM   *ap;
{
	if(na == 0)	{
		zerofile();
		rdx.v.ivalu = 0;
		}
	else	{
		rewind( (FILE *) ap[0].v.ivalu);
		rdx.v.ivalu = 1;
		}
	pusher = ipush;
}
void
kfflush(na,ap)
int     na;
DATUM   *ap;
{
	rdx.v.ivalu = (int) fflush(stdout);
	if(na == 0 && ofp != stdout) rdx.v.ivalu = (int) fflush(ofp);
	else
	if(na == 1)	rdx.v.ivalu = (int) fflush((FILE*) ap[0].v.ivalu);
    pusher = ipush;
}
void
kfopen(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = (int)    	tefopen(ap[0].v.ptr,ap[1].v.ptr);
    pusher = ipush;
}
void
kfclose(na,ap)
int     na;
DATUM   *ap;
{
	auto	FILE	*fp;
	if(na == 1)	fp = (FILE *) ap[0].v.ivalu;
	else		{ fp = cfp; cfp = NULL; }
    rdx.v.ivalu = (int)    	xfclose( fp );
    pusher = ipush;
}
void
ksetfile(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = termfile(ap[0].v.ptr);
    pusher = spush;
}
void
krdline(na,ap)          /* read a line */
int     na;
DATUM   *ap;
{
	kfgetlx(na,ap,(FUNCP) fgetlf,"fgetlf");
}
void
kfgetls(na,ap)
int     na;
DATUM   *ap;
{
	kfgetlx(na,ap,(FUNCP) fgetls,"fgetls");
}
void
kfgetlf(na,ap)
int     na;
DATUM   *ap;
{
	kfgetlx(na,ap,(FUNCP) fgetlf,"fgetlf");
}
void
kfgetlx(na,ap,func,is)
int     na;
DATUM   *ap;
FUNCP	func;
char	*is;
{
	auto	char	*os;
	auto	char	*us;
	auto	FILE	*fp;
	auto	char	*xp = NULL;
/**/
	os = ap[0].v.ptr;
	us = os + ap[1].v.ivalu - 2;
/**/
	if(na == 2)	{
		while( (int) (fp = getfile()) )	{
			xp = 			(char *) (*func)(os,us,fp);
			if(xp)			break;
			else
			if(fgetlerr())	break;
			else			continue;
		}
	}
	else
	if(na == 3)	{
		fp = (FILE *) ap[2].v.ivalu;
    	xp = (char *) (*func)(os,us,fp);
		}
/**/
	rdx.v.ptr = xp;
/**/
    pusher = spush;
}
void
kfgetlerr(na,ap)
int		na;
DATUM	*ap;
{
	rdx.v.ivalu = fgetlerr();
	pusher = ipush;
}
void
kputchar(na,ap)
int		na;
DATUM	*ap;
{
	rdx.v.ivalu = fputc( ap[0].v.ivalu, ofp );
	pusher = ipush;
}
void
kungetc(na,ap)
int		na;
DATUM	*ap;
{
	rdx.v.ivalu = ungetc( ap[0].v.ivalu, (FILE *) ap[1].v.ivalu );
	pusher = ipush;
}
void
kgetchar(na,ap)
int		na;
DATUM	*ap;
{
	rdx.v.ivalu = getc( stdin );
	pusher = ipush;
}
void
kgetc(na,ap)
int		na;
DATUM	*ap;
{
	if(na == 0)	rdx.v.ivalu = getc(stdin);
	else		rdx.v.ivalu = getc( (FILE *) ap[0].v.ivalu);
	pusher = ipush;
}
void
kfunxesc(na,ap)
int     na;
DATUM   *ap;
{
    if(na == 1) rdx.v.ptr =    	funxesc(ap[0].v.ptr,ofp);
    else
    if(na == 2) rdx.v.ptr =    	funxesc(ap[0].v.ptr,(FILE *) ap[1].v.ivalu);
    pusher = spush;
}

void
ksetofn(na,ap)
int     na;
DATUM   *ap;
{
    if(na == 0) rdx.v.ptr = (POINTER) setofn(NULL,NULL);
    else
    if(na == 1) rdx.v.ptr = (POINTER) setofn(ap[0].v.ptr,"w");
    else
    if(na == 2) rdx.v.ptr = (POINTER) setofn(ap[0].v.ptr,ap[1].v.ptr);
    pusher = spush;
}
void
ksetifn(na,ap)		/* set input files */
int	na;
DATUM	*ap;
{
	if(na == 0)	{
		rdx.v.ptr = rfn;
		zerofile();
		}
	else	{
		rdx.v.ptr = termfile(ap[0].v.ptr);
		}
	pusher = spush;
}
