#define 	NEW_CODE
#undef		NEW_CODE
/*
	88:03:14 - fixed bug involving multiple free(s) of symbols
	used as array elements.
*/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
/**/
#include	"ksysprot.h"
#include	"kawkfunc.h"
#define		memnull(a,b)memset(a,0,b)
/**/
/*EXTERN*/
extern	void	allok();
/*GLOBAL*/
/*STATIC*/
/**/
#ifdef	NEW_CODE
char    *
defncomp(is,type)
char    *is;
int     type;   /* variable type supplied by calling routine */
{
	auto	FUNCP	fu = (FUNCP) NULL;
	auto	SYMBOL	*sym;
    REG     char    *isx = is;
    auto    char    *vnm = NULL;
    auto    int     dim = 0;         /* dimension */
    auto    int     esiz = 0;      /* element size */
    auto    int     tsiz = 0;      /* total size */
    while(isx && (int) (isx = skipbs(isx)))   {
/**/
    esiz = tsiz = dim = 0;
/**/
    isx = namepull(isx);
/**/
    vnm = nameretr();
/**/
	fu = isbuiltin(vnm);
	if(fu != (FUNCP) NULL)	{
			errptr(isx,"<variable given function name>\n");
			}
/**/
    if(*isx == '*') {
		errptr(isx,"<pointers are not implemented>");
		}
/**/
/*	change for multiple dimensions */
/**/
    if(*isx == '[') {
/**/
	isx = getdim(isx,&dim);
/**/
        isx = skipbs(isx);
        if(dim <= 1)             errptr(is,"<dimension error>");
        if(*isx++ != ']')       errptr(is,"<dimension syntax>");
/**/
        isx = skipbs(isx);
	}
/**/
	esiz = tysize(type,is);
/**/
	tsiz = dim ? (esiz * dim) : (esiz * 1);
/**/
    tsiz /= esiz;
/*
**  tsiz is in terms of esiz units
**  for simple variables esiz == tsiz
**  for constants tsiz == 0
*/
    sym = addsym(vnm,type,NULL,esiz,tsiz);
/**/
	addcode(allok,"ALLOK");
/**/
	addcode( (INST) sym, "SYMBOL");
/**/
    if(*isx != ',')     break;
    else                isx += 1;
/**/
    }
    return(isx);
}
tysize(ty,is)
int	ty;
char	*is;
{
	auto	int	ts;
    switch(ty)    {
		case	VFLOAT:
		case	VDOUBLE:	ts = sizeof(double);
                            break;
		case	VLONG:
        case    VINT:       ts = sizeof(int);
                            break;
        case    VCHAR:      ts = sizeof(char);
                            break;
        default:            errptr(is,"<bad type>");
                            break;
        }
	return(ts);
}
#else
char    *
defncomp(is,type)	/* allocate space for variable */
char    	*is;	/* name of variable */
NOSIGN     type;   	/* variable type supplied by calling routine */
{
    auto    POINTER adr = NULL;
    REG     char    *isx = is;
    auto    char    *nme = NULL;
    auto    int     nd = 0;         /* dimension */
    auto    int     pt = 0;         /* pointer switch */
    auto    int     esize = 0;      /* element size */
    auto    int     tsize = 0;      /* total size */
    while((int) isx && (int) (isx = skipbs(isx)))   {
    esize = tsize = pt = nd = 0;
    isx = namepull(isx);
    nme = nameretr();
    if(*isx == '*') {
        isx += 1;
        pt = 1;
        esize = sizeof(POINTER);
        }
/*
**  change for multiple dimensions
*/
    if(*isx == '[') {
        if(strncmp(isx+1,"BUFSIZ",6) == 0)  {
            isx += 7;
            nd = BLKSIZ;
            }
        else    {
            nd = atoi(++isx);
            while(isdigit(*isx))    ++isx;
            }
        isx = skipbs(isx);
        if(nd <= 1)             errptr(is,"<dimension error>");
        if(*isx++ != ']')       errptr(is,"<dimension syntax>");
        isx = skipbs(isx);
        }
/**/
	if(!pt)	esize = typesize(type,is);
/**/
	tsize = nd ? (esize * nd) : (esize * 1);
/**/
	adr = malloc(tsize);
    if(adr == NULL)     errptr(is,"defcomp <no core>");
    memnull(adr,tsize);
/**/
if(kenv.report & DA)
	printff("defncomp: adr %u %u\n",adr,tsize);
/**/
    tsize /= esize;
/*
**  tsize is in terms of esize units
**  for simple variables esize == tsize
**  for constants tsize == 0
*/
    addsym(nme,type,adr,esize,tsize, (FUNCP) NULL);
    if(*isx != ',')     break;
    else                isx += 1;
    }
    return(isx);
}
typesize(ty,is)
int	ty;
char	*is;
{
	auto	int	ts;
    switch(ty)    {
		case	VFLOAT:
		case	VDOUBLE:	ts = sizeof(double);
                            break;
		case	VLONG:
        case    VINT:       ts = sizeof(int);
                            break;
        case    VCHAR:      ts = sizeof(char);
                            break;
        default:            errptr(is,"<bad type>");
                            break;
        }
	return(ts);
}
#endif
SYMBOL  *
addsym(name,type,adr,esize,tsize,func)
char    *name;      /* variable name */
NOSIGN  type;       /* variable type */
POINTER adr;        /* address of variable */
NOSIGN  esize;      /* size of one element */
NOSIGN  tsize;      /* size of whole structure (in element units) */
INST	func;		/* pointer to a function */
{
/*
**  record symbol names and size data in
**  chained array
**  adr points to storage of proper type
*/
    SYMBOL  *scurt = NULL;
    if(isnull(name))    ;
    else
    if(retrsym(name))   {
        errmsg("addsym <redefined symbol> '%.10s'\n",name);
        terror(FUBAR);
        }
/*  make a chain element */
    if(!(scurt = (SYMBOL *) malloc(sizeof (SYMBOL))))   {
        errmsg("addsym <no core>\n");
        terror(FUBAR);
        }
    scurt->snext = (SYMBOL *) NULL;
    scurt->name = NULL;
/**/
    if(!isnull(name))   {
        scurt->name = strsave(name);
            if(scurt->name == NULL) {
            errmsg("addsym <no core>\n");
            terror(FUBAR);
            return(NULL);
            }
        }
/**/
/*###kasym.c(224) : warning 51: data conversion???*/
    scurt->type = type;
/*###kasym.c(225) : warning 51: data conversion???*/
    scurt->esize = esize;
    scurt->tsize = tsize;
    if(type != VFUNC)
	    scurt->off = scurt->adr = adr;
    if(sbase == NULL)   sbase = scurt;
    if(slast)           slast->snext = scurt;
    return(slast = scurt);
}
SYMBOL  *
retrsym(is)         /* return symbol or NULL */
char    *is;
{
    SYMBOL  *scx = sbase;
    while(scx != (SYMBOL *) NULL)  {
        if(scx->name && *scx->name == *is &&
            strcmp(scx->name,is) == 0)  return(scx);
        scx = scx->snext;
    }
    return((SYMBOL *) NULL);
}
SYMBOL  *
clrsym()            /* clear and free symbol table */
{
    auto    SYMBOL  *stx = sbase;
	auto	SYMBOL	*stz;
    while(stx != NULL)  {
		if(stx->type != VFUNC)	{
        	free_if(stx->name);
        	free_if(stx->adr);
			stz = stx->snext;
			while(stz != NULL)	{
				if(stx->name == stz->name)	stz->name = NULL;
				if(stx->adr == stz->adr)	stz->adr = NULL;
				stz = stz->snext;
				}
			}
        free_if((char *) stx);
        stx = stx->snext;
    }
    return(sbase = slast = NULL);
}
char    *
strcomp(is)         /* compile string constant */
char    *is;
{
    auto    SYMBOL  *sym;
    auto    char    ws[BLKSIZ];
    auto    char    *str = NULL;
    REG     char    *isx = is;
	auto	int		tc = *isx;
/**/
	isx = xgnc(ws,ws+BLKSIZ-1,isx+1,tc);
/**/
	if(xgncl() != tc)	
		errptr(is,"<missing termination>\n");
/**/
	xesc(ws);	
/**/
    if(!(str = strsave(ws)))
		errptr(is,"<no core for string>");
/*
**  total size given as 0 to indicate no assignment
**  possible
*/
    sym = addsym("",VSTRING,str,sizeof(char),0, (FUNCP) NULL);
/**/
    addcode( (FUNCP) xconst,"xconst");
/**/
    symcode((INST) sym, "STRING");
/**/
    return(skipbs(isx));
}
char	*
getdim(is,dim)
char	*is;
int	*dim;
{
        if(strncmp(is+1,"BUFSIZ",6) == 0)  {
            is += 7;
            *dim = BLKSIZ;
            }
		else
        if(strncmp(is+1,"FNMSIZ",6) == 0)  {
            is += 7;
            *dim = FNMSIZ;
            }
        else    {
            *dim = atoi(++is);
            while(isdigit(*is))    ++is;
            }
	return(skipbs(is));
}
