#define		BIGIOBUF	10240
/**/
#define		BUFWIPE		/* USE IN ALL VERSIONS */
/**/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include    "kedfuncs.h"
#include	"keyproto.h"
/**/
#define		ALLOC_CBT
#include	"kedbuffr.h"
/**/
#include    <signal.h>
/**/
#define		RECPERM		"r+"	/* must not be "a+" */
#define		REGPERM		"w+"	/* regular mode */
#define		memnull(a,b)memset(a,0,b)
#define     MAGIC       891002
/**/
static	char	*tmpdir;		/* dir for temp files */
/**/
/*EXTERN*/
/**/
#ifdef		BIGKED
#ifdef		__TURBOC__
#define		bigmalloc(a)farmalloc(a)
#define		bigfree(a)farfree(a)
#else		/*__TURBOC__*/
#define		bigmalloc(a)far_malloc(a)
#define		bigfree(a)far_free(a)
#endif		/*__TURBOC__*/
#else		/*BIGKED*/
#define		far		/**/
#define		bigmalloc(a)malloc((NOSIGN) a)
#define		bigfree(a)free(a)
#endif		/*BEGKED*/
#ifdef		CAN_PROTO
#ifdef		__TURBOC__
#include	<alloc.h>
#else		/*__TURBOC__*/
#include	"faralloc.h"
#endif		/*__TURBOC__*/
static int (*xundo)(char far *, NOSIGN, NOSIGN, FILE *);
extern int efread( char far *, NOSIGN, NOSIGN, FILE *);
extern int efwrite( char far *, NOSIGN, NOSIGN, FILE *);
#else		/*CAN_PROTO*/
static int (*xundo)();
extern int efread();
extern int efwrite();
#endif		/*CAN_PROTO*/
/**/
char	far	*
bigbuf(nc)
NOSIGN	nc;
{
	static	char	far		*bs = (char far *) NULL;
	auto	long			size;
	if(bs != (char far *) NULL)	bigfree( bs );
	bs = (char far *) NULL;
/**/
	do	{
		size = (long) (nc + 4) * (long) sizeof(CBT);
		bs = bigmalloc( size );
		if(bs != (char far *) NULL)	break;
		nc -= BUFSIZ;
		}	while(nc >= BUFSIZ)	;
/**/
	cdx.max = nc;
/**/
	{
	REG		char	far		*bsx = bs;
	REG		long			ncx = nc;
	while(ncx-- >= 1)	{
		*bsx++ = 0;
		}
	}
/**/
	return( bs );
}
void
flagsoff(lx,nx)     /* make sure no flags on from global */
CBT     far	*lx;
int   	nx;
{
    REG     CBT     far	*cbx = lx;
    REG     CBT     far	*cbu = cbx + nx;
/**/
    while(cbx < cbu)    {
        cbx->tags.chgd = cbx->tags.glob = NO;
        cbx += 1;
    }
/**/
	return;
}
void
efioerr(is)
char	*is;
{
	prterr(is);
	terror(FUBAR);
	return;
}
efwrite(bs,size,nelm,fp)
char	far	*bs;		/* buffer to write */
NOSIGN		size;		/* size of item */
NOSIGN		nelm;		/* number of items */
FILE		*fp;
{
	REG		long	ncx = size * nelm;
	REG		char	far	*bsx = bs;
	while(ncx-- >= 1)	putc(*bsx++,fp);
	if(ferror(fp))		efioerr("fwrite");
	return(nelm);
}
efread(bs,size,nelm,fp)
char	far	*bs;
NOSIGN		size;
NOSIGN		nelm;
FILE		*fp;
{
	REG		long		ncx = size * nelm;
	REG		char		far	*bsx = bs;
	while(ncx-- >= 1)	*bsx++ = getc(fp);
	if(ferror(fp))		efioerr("fread");
	return(nelm);
}
/**/
char	*
set_tmp_dir(is)	/* set tmpdir */
char	*is;
{
	tmpdir = free_if(tmpdir);
	return(tmpdir = strsave(is));
}
long
tblsize(is)     /* current buffer size */
char    *is;
{
	if(kenv.dosdos)	{
		system("exec");		/* force a system flush */
		}
	return(filesize(is));
}
/**/
char    *
bfnset(is,mo)       /* set and open buffer file */
char    *is;        /* name (if recovery) */
char    *mo;        /* mode */
{
    static  char    *ubr = NULL;
/**/
	if(!(kenv.keying & DA))	{
		errmsg("bfnset: <no keys>\n");
		terror(FUBAR);
		}
/**/
    if(!isnull(is)) {
        strkat(bfn,bfn+FNMSIZ-1,is);
        }
    else	{
		tmpdir = (tmpdir = kgetenv("BUFDIR")) ? tmpdir : ".";
		strcpy(bfn,tmpdir);
		strcat(bfn,"/kdXXXXXX.rec");
		maketemp(bfn);
		}
/**/
	bfp = tefopen(bfn,mo);
#ifdef	SYSV
    ubr = ksetvbuf(bfp,ubr,_IOFBF,BIGIOBUF);
#endif /*SYSV*/
    rewind(bfp);
/**/
    return(bfn);
}
undo(ty,is)    	/* read or write undo buffer */
NOSIGN	ty;		/* function type */
char	*is;	/* calling routine: DEBUG */
{
    auto    int     cur = cdx.cur;
	auto	FUNCS	sigint = (FUNCS) NULL;
	auto	char	*fn = "shit";
	auto	NOSIGN	ulatch = ub.ulatch;
/**/
    if(bfp == NULL || ub.canund == NO) return(ZERO);
/**/
	if(ty & BCLS)	{
			bfp = xfclose(bfp);
			return(ZERO);
			}
/**/
	sigint = signal(SIGINT,SIG_IGN);
/**/
    cdx.con = YES;
/**/
    if( (ty & BWRT) || (ty & BPRE) )  {
		fn = "bwrt";
        xundo = efwrite;
        flagsoff(cbt,cdx.lst);
		time(&ub.utime[ub.ulatch]);
        }
    else
    if(ty & BRDD)  {
		fn = "brdd";
        xundo = efread;
        }
/**/
	efseek(bfp,0L,0);
	(*xundo)((char *) &ub, sizeof(UNDOBUF) , 1, bfp);
	if( (ty & BPRE) )	{
		sigint = signal(SIGINT,(FUNCS) sigint);
		return(0);
		}
	ub.ulatch = ulatch;
	efseek(bfp,ub.editfn,0);
	(*xundo)(efn, FNMSIZ, 1, bfp);
/**/
	efseek(bfp,ub.cdxbuf[ub.ulatch],0);
    (*xundo)((char *) &cdx,sizeof(CDACT),1,bfp);
/**/
	if(ty & BREC)	setlist( cdx.max );
/**/
	efseek(bfp,ub.cbtbuf[ub.ulatch],0);
	(*xundo)((char far *) cbt, sizeof(CBT), cdx.lst +1, bfp);
/**/
    if(cur >= 1 && cur <= cdx.lst)          cdx.cur = cur;
/**/
	ub.ulatch = flop(ub.ulatch);
	fflush(bfp);
/**/
	sigint = signal(SIGINT,(FUNCS) sigint);
/**/
    cdx.con = YES;
/**/
	return(0);
}
void
undop()		/* position on last record addressed */
{
	undo(BRDD,"undop");
	if(kenv.prompt)	{
		if(kenv.leisur & DA)    scr_cl(stdout);
		printff("<undone>\n");
		pcmd0("#");
		}
	return;
}
clredit()   /* close and remove buffer, work files */
{
/**/
	memnull( (char *) &cdx, sizeof(CDACT) );
	memnull( (char *) &ub, sizeof(UNDOBUF) );
/**/
	efclean(NULL);
	bfp = NULL;
/**/
    if(!isnull(bfn))    unlink(bfn);
    if(!isnull(wfn))    unlink(wfn);
/**/
    wfn[0] = bfn[0] = ZERO;
/**/
    return(cdx.con = YES);
}
bufchk()	/* check buffer format */
{
    if(ub.magic != MAGIC)   {
        errmsg("bufchk <bad buffer format> '%s' %ld != %ld\n",
			bfn,ub.magic,MAGIC);
        bfp = xfclose(bfp);
        bfn[0] = ZERO;
        terror(FUBAR);
        }
	return(0);
}
long
round(ad,ax,is)
long	ad;
long	ax;
char	*is;
{
	auto	long	block = (long) BLKSIZ;
	auto	long	total = ad + ax;
	block = block - (total % block);
	total += block;
	return(total);
}
bufbld(is)      /* setup editor and undo buffers */
char    *is;
{
	auto	long	bsize = 0L;
    setlist(0);
    if(!bfp)    bfnset(NULL,REGPERM);
/*  calculate size of preface */
    ub.canund = 1;
    ub.magic = MAGIC;
    cdx.lst = cdx.max;
	bsize = ub.header = round( (long) 0, bsize, "header");
	bsize = ub.editfn = round( (long) sizeof(UNDOBUF), bsize, "editfn");
	bsize = ub.cdxbuf[0] = round( (long) FNMSIZ, bsize, "cdxbuf[0]");
	bsize = ub.cdxbuf[1] = round( (long) sizeof(CBT), bsize, "cdxbuf[1]");
	bsize = ub.cbtbuf[0] = round( (long) sizeof(CBT), bsize, "cbtbuf[0]");
	bsize = ub.cbtbuf[1] = round( ub.cbtsiz, bsize, "cbtbuf[1]");
    bsize = ub.ebufl[0] = round( ub.cbtsiz, bsize, "ebufl[0]");
    bsize = ub.ebufl[1] = round( (long) kb.bsize, bsize, "eubufl[1]");
    bsize = ub.lastloc  = round( (long) kb.bsize, bsize, "lastloc");
/**/
#ifdef	BUFWIPE
	bufwipe(bsize);
#endif	BUFWIPE
	rewind(bfp);
/**/
    cdx.lst = 0;
/*  read the first file, if any */
    if(isnull(efn)) errmsg("<no edit file name>\n");
    else            {
		orphans('e',"bufbld",NULL);	/* ORPHANS */
		undo(BPRE,"bufbld");
		doread(0,efn);
		}
/**/
/*  write initial buffers for this */
    cdx.cur = 1;
    cdx.chg = cdx.del = 0;
    undo(BWRT,"bufbld");
    undo(BWRT,"bufbld");
    return(cdx.con=YES);
}
#ifdef	BUFWIPE
bufwipe(nc)		/* initial disk (for msdos) */
long	nc;
{
	auto	char	bs[BLKSIZ];
	auto	NOSIGN	nb = 0;
	memnull(bs, BLKSIZ);
	while(nc-- >= 1L)	{
		fwrite(bs, BLKSIZ, 1, bfp);
		nc -= BLKSIZ;
		nb += 1;
		}
	return(nb);
}
#endif	BUFWIPE
void
doreco(is)  /* set up recovery operation */
char    *is;
{
	auto	long	t1;
	auto	long	t2;
	auto	int		shit = 0;
    clredit();
	if(access(is,06))	{
		errmsg("doreco <bad file> '%s'\n",is);
		terror(FUBAR);
		}    	
	t1 = filemraw(is);
	bfnset(is,RECPERM);
	ub.canund = cdx.con = ub.recovr = YES;
/**/
	orphans('X',"doreco",NULL);
    undo(BRDD | BREC,"doreco");
	if(ub.ulatch == ZERO)	undo(BRDD | BREC,"doreco");
/**/
	addget();
	addbuf(ADDCLS);
/**/
	t2 = filemraw(efn);
	if(t2 > 0L && t2 > t1)	{
		prwho(" <file changed since buffer saved>\n");
		}
/**/
	t2 = filemraw(keysget());
	if(t2 > 0L && t2 > t1)	{
		prwho(" <keys changed since buffer saved>\n");
		}
/**/
	prwho(" %u cards for %s saved %s\n",cdx.lst,efn,filemtime(bfn));
/**/
	return;
}
putcd(ty)   /* write one card to scratch */
int   ty;
{
    if(cdx.lst < cdx.max) {
        cdx.con = cdb(++cdx.lst,ty);
        moveblk(cdx.lst,cdx.lst,cdx.cur);
        ++cdx.cur;
        return(cdx.con);
        }
    else    {
        errmsg("<too many cards>\n");
        return(cdx.con = NO);
        }
}
chgcd(nc,ty)    /* write card to buffer replacing current */
int	  nc;
int	  ty;
{
    return(cdx.con = cdb(nc,ty));
}
geterr(nc)      /* check for read error */
int		nc;		/* card number */
{
    auto    char        *err = rderr(NULL);
	if(!isnull(err))	{
		if(kenv.prompt)	{
			mvtocd(nc);
			kb.used = xrdcd(kb.base,kb.bmax,bfp);
			xwrcdf(kb.base,stderr,kenv.folder,NULL);
			}
        errmsg("card %d <unknown or duplicated key> '%s'\n",nc,err);
        return(1);
        }
    else    return(0);
}
getcd(nc,ty)    /* get one card from scratch */
int	  nc;
int   ty;
{
    mvtocd(nc);
    if(ty == LINE_IO)     {
		kb.base[0] = LF;
        kb.used = xrdcd(kb.base+1,kb.bmax,bfp) + 1;
        }
    else
    if(ty == CARD_IO)   {
        clcd();
        if(!rdcd(bfp,'v'))  return(geterr(nc));
        }
    else                {
        if(!rdcd(bfp,ty))   return(geterr(nc));
        }
	if(ferror(bfp))		{
		errmsg("getcd <read error>\n");
		terror(FUBAR);
		}
    return(0);
}
addcds(nc,is)       /* add cards after nc from file is */
char    *is;
int	  	nc;
{
	extern	long	ftell();
	extern	long	filesize();
    auto    NOSIGN  cnt = 0;
    auto    NOSIGN 	nbeg = 0;
	auto	double	size = (double) filesize(is);
    auto    FILE    *fp = NULL;
	fp = tefopen(is,"r");
#ifdef	SYSV
    ifb = ksetvbuf(fp,ifb,_IOFBF,kenv.blockd);
#endif	/*SYSV*/
    cdx.cur = nc;
    nbeg = cdx.lst + 1;
    cdx.con = YES;
    while(cdx.con && cdx.lst < cdx.max && xrdcd(kb.base,kb.bmax,fp)) {
        if(!isalnum(kb.base[0]))  {
            errmsg("addcds <funny card>\n");
            if(kenv.prompt) {
                xlwrcdf(kb.base,stderr,kenv.folder);
                }
            break;
        }
    cdx.con = cdb(++cdx.lst,LINE_IO);
    cnt += 1;
/**/
	if(kenv.prompt && cnt % 100 == 0)	{
		auto	double	percent;
		percent = (double) ftell(fp) * (double) 100;
		percent /= size;
		printff("%5d %4.1f%c\r",cnt,percent,'%');
		}
    }
/**/
    xfclose(fp);
    if(cdx.lst >= cdx.max)  {
        errmsg("<too many cards> '%s'\n",is);
        }
    moveblk(nbeg,cdx.lst,cdx.cur);
	ifb = free_if(ifb);
    return(cnt);
}
addget()	/* recover data from an append::insert */
{
	auto	int		cnt = ZERO;
	auto	char	*lcf = "lostcard.sve";
	auto	FILE	*sfp;
/**/
	if(ub.addbuf[0] == ub.addbuf[1])	return(cnt);
/**/
	sfp = efopen(lcf,"a");
	if(sfp == (FILE *) NULL)			return(-1);
/**/
	while(ub.addbuf[0] < ub.addbuf[1])	{
		efseek(bfp,ub.addbuf[0],0);
		xrdcd(kb.base,kb.bmax,bfp);
		xwrcd(kb.base,sfp);
		ub.addbuf[0] = ftell(bfp);
		cnt += 1;
		}
/**/
	sfp = xfclose(sfp);
	ub.addbuf[0] = ub.addbuf[1] = 0L;
/**/
	if(cnt >= 1)	{
		printff("saved %d (possibly) lost cards to '%s'\n",cnt,lcf);
		printff("recover with 'r %s' then delete '%s'\n",lcf,lcf);
		query(stdout);
		}
	return(cnt);
/**/
}
cdb(nc,ty)  /* write one card to end of buffer file */
int	  nc;
int	  ty;
{
/**/
	efseek(bfp,0L,2);
/**/
	cbt[nc].addr = ftell(bfp);
/**/
	if(ty == LINE_IO)       xwrcd(kb.base,bfp);
	else
	if(ty == CARD_IO)       wrcd(bfp,'w',0);
/**/
	if(ferror(bfp))	{
		prterr("cdb <no space?> '%s'",bfn);
		terror(FUBAR);
		}
/**/
	if(kenv.buffer & DA)    {
		cbx = cbt + nc;
		cbx->tags.hash = cdhash(nc,ty);
		/* cbt[nc].tags.hash = cdhash(nc,ty); */
		}
/**/
	fflush(bfp);
/**/
	ub.lastloc = ftell(bfp);
    return(cdx.con);
}
nextcd(nc)
int	  nc;
{
    if(cdx.lst <= 1)    {
        errmsg("nextcd <TURKEY!>\n");
        terror(FUBAR);
        }
    nc += 1;
    nc = (nc <= cdx.lst) ? nc : 1;
    return(nc);
}
prevcd(nc)
int	  nc;
{
    if(cdx.lst <= 1)    {
        errmsg("prevcd <TURKEY!>\n");
        terror(FUBAR);
        }
    nc -= 1;
    nc = (nc >= 1) ? nc : cdx.lst;
    return(nc);
}
mvtocd(nc)   /* move to card n */
int	  nc;
{
    if(nc <= 0 || nc > cdx.lst) {
        errmsg("<bad address>\n");
        terror(FUBAR);
    }
    return(efseek(bfp,cbt[nc].addr,0));
}
showcbt(fp)
FILE	*fp;
{
	auto	NOSIGN	ix;
	for(ix = 0; ix < cdx.lst;ix++)	{
		if(ix % 10 == 0)	fprintf(fp,"\n%4d ",ix);
		fprintf(fp,"%6ld ",cbt[ix].addr);
		}
	fprintf(fp,"\n");
	return;
}
NOSIGN
setlist(nc)   /* storage for pointer list */
NOSIGN    nc;
{
/**/
	static	char	*here = "setlist";
/**/
	auto	NOSIGN		want;
/**/
	if(!nc) {
		cdx.max = cardsget();
		cdx.max = cdx.max >= BLKSIZ ? cdx.max : BLKSIZ;
		}
	else	cdx.max = nc;
	want = cdx.max;
/**/
	cbt = (CBT far *) bigbuf( cdx.max );
	ub.cbtsiz = (long) cdx.max * (long) sizeof(CBT);
/**/
	if(cdx.max != want)	{
		errmsg("%s <buffer reduced> %u cards maximum\n",
			here,cdx.max);
        }
/**/
    return(cdx.max);
}
void
moveblk(n1,n2,n3)   /* from Software Tools in Pascal, p. 195 */
int		n1;		/* first card to move */
int		n2;		/* last card to move */
int		n3;		/* target (moved cards after this) */
{
    if(n3 < (n1 - 1) ) {
        flip(n3 + 1, n1 -1);
        flip(n1, n2);
        flip(n3 + 1, n2);
		}
    else
	if(n3 > n2) {
        flip(n1, n2);
        flip(n2 + 1, n3);
        flip(n1, n3);
		}
}
void
addbuf(ty)	/* save data on append::insert for recovery */
int		ty;
{
	if(ty == ADDBEG)	{
		ub.addbuf[0] = ub.lastloc;
		}
	else
	if(ty == ADDEND)	{
		ub.addbuf[1] = ub.lastloc;
		undo(BPRE,"addbuf");
		}
	else
	if(ty == ADDCLS)	{
		ub.addbuf[0] = ub.addbuf[1] = 0L;
		}
	return;
}
void
flip(n1,n2)         /* from Software Tools in Pascal */
int 	n1;
int 	n2;
{
    auto     CBT     nx;
    while(n1 < n2) {
		nx = cbt[n2];
		cbt[n2] = cbt[n1];
		cbt[n1] = nx;
        n1 += 1;
        n2 -= 1;
    }
}
/**/
char    *
efnset(is)      /* set (store) the edit file name */
char    *is;
{
    if(isnull(is))  return(efn);
    else            {
		auto	char	*file = fexpand(is);
        strcpy(efn,file);
		file = free_if(file);
        return(efn);
        }
}
char    *
efnget()        /* return the edit file name */
{
    return(efn);
}
