#define		DEBUG
#undef		DEBUG
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#ifdef		__TURBOC__
#include	<io.h>
#else		/*__TURBOC__*/
#include	<sys/types.h>
#include	<sys/file.h>
#endif		/*__TURBOC__*/
#define		NEW		1
#define		OLD		2
#define	B_INUSE		FUBAR
#define	B_ORPHAN	FUBAR
#define	B_BAD_TYPE	FUBAR
#define	B_OKAY		0
#ifndef		R_OK
#define		R_OK			04
#endif		/*R_OK*/
#ifndef		L_cuserid
#define		L_cuserid		32
#endif		/*L_cuserid*/
#define		MAXORPH			256
KENV		kenv;
char		ls[BUFSIZ];
typedef	struct	ORPHANS	{
	int		o_type;				/* type, status */
	int		o_user;				/* process id of user */
	char	o_name[L_cuserid];	/* name of user */
	char	o_edit[FNMSIZ];		/* edit file name */
	int		o_enum;				/* inumber of edit file */
	char	o_bufr[FNMSIZ];		/* buffer file name */
	int		o_bnum;				/* inumber of buffer file */
	}	ORPHANS;
ORPHANS		want;
ORPHANS		have;
/*GLOBAL*/
int		perm = 0777;
long	lastread;
ORPHANS	*table[MAXORPH];
/*EXTERN*/
#ifdef	CAN_PROTO
#ifdef	__TURBOC__
extern void prterr(char *, ...);
extern void errmsg(char *, ...);
#endif	/*__TURBOC__*/
extern int scantable(void);
extern char *lockfile(void);
extern char *lockfile(void);
extern char *cuserid(char *);
extern ORPHANS *havebufr(ORPHANS *);
extern int kill(int, int);
extern ORPHANS *swablock(ORPHANS *, ORPHANS *);
extern int writetable(FILE *);
extern int newedit(ORPHANS *);
extern int isalive(ORPHANS *, ORPHANS *);
extern ORPHANS *havebufr(ORPHANS *);
extern int canweuse(ORPHANS *,ORPHANS *);
extern ORPHANS *haveedit(ORPHANS *);
extern int readtable(FILE *);
extern int showlock(FILE *, ORPHANS *);
#else	/*CAN_PROTO*/
extern int scantable();
extern char *lockfile();
extern char *lockfile();
extern char *cuserid();
extern ORPHANS *havebufr();
extern int kill();
extern ORPHANS *swablock();
extern void prterr();
extern int writetable();
extern int newedit();
extern int isalive();
extern ORPHANS *havebufr();
extern void errmsg();
extern int canweuse();
extern ORPHANS *haveedit();
extern int readtable();
extern int showlock();
#endif	/*CAN_PROTO*/
canweuse(want,have)
ORPHANS	*want;
ORPHANS	*have;
{
	auto	int		ret = 0;
	readtable(kenv.ofptr);
	switch(want->o_type)	{
	case	'l':
		have = haveedit(want);
		if(have)	{
			showlock(stdout,have);
			return(B_OKAY);
			}
		else	{
			errmsg("<no entry> '%s'\n",want->o_edit);
			return(FUBAR);
			}
		break;
	case	's':
		scantable();
		return(B_OKAY);
		break;
	case	'e':
		have = haveedit(want);
		if(have && (ret = isalive(want,have)))	return(ret);
		kenv.buffer = newedit(want);
		kenv.buffer = writetable(kenv.ofptr);
		return(B_OKAY);
		break;
	case	'q':
		want->o_type = 'u';
	case	'u':
	case	'x':
		have = havebufr(want);
		if(!have)	{
			errmsg("<no lock table entry>\n");
			query(stderr);
			kenv.buffer = newedit(have = want);
			}
		swablock(have,want);
		have->o_user = 0;
		kenv.buffer = writetable(kenv.ofptr);
		return(B_OKAY);
		break;
	case	'X':
		have = havebufr(want);
		if(have && (ret = isalive(want,have)))	return(ret);
		if(!have)	{
			errmsg("<no lock table entry>\n");
			query(stderr);
			kenv.buffer = newedit(have = want);
			}
		have->o_type = 'e';
		have->o_user = want->o_user;
		kenv.buffer = writetable(kenv.ofptr);
		return(B_OKAY);
		break;
	default:
		errmsg("<unknown function> '%c'\n",want->o_type);
		return(B_BAD_TYPE);
	}
}
writetable(fp)
FILE	*fp;
{
	auto	int		ix;
	auto	int		jx;
	fp = freopen(kenv.ofnme,"w",fp);
	if(!fp)	{
		prterr("freopen: %s\n",kenv.ofnme);
		exit(FUBAR);
		}
	chmod(kenv.ofnme,perm);
	for(jx = ix = 0; ix < kenv.buffer; ix++)	{
		if(strcmp(table[ix]->o_edit,"NONE") == 0)	continue;
		if(table[ix]->o_type == 'u')				continue;
		fwrite((char *) table[ix],sizeof(ORPHANS),1,fp);
#ifdef	DEBUG
		orphprint(stderr,table[ix],"writetable");
#endif	/*DEBUG*/
		jx += 1;
		}
	return(jx);
}
ORPHANS *
swablock(want,have)
ORPHANS	*want;
ORPHANS *have;
{
	memcpy((char *) want, (char *) have, sizeof(ORPHANS));
	return( want );
}
newedit(want)
ORPHANS	*want;
{
	table[kenv.buffer] = (ORPHANS *) malloc(sizeof(ORPHANS));
	memcpy((char *) table[kenv.buffer], (char *) want, sizeof(ORPHANS));
#ifdef	DEBUG
	orphprint(stderr,table[kenv.buffer],"newedit");
	query(stderr);
#endif	/*DEBUG*/
	kenv.buffer += 1;
	return(kenv.buffer);
}
isalive(want,have)
ORPHANS	*want;
ORPHANS	*have;
{
	if(want->o_type == 'e')	{
		if(have->o_user && kill(have->o_user,0) == 0)	{
			errmsg("<in use> %u %s\n",have->o_user,have->o_name);
			return(B_INUSE);
			}
		else	{
#ifdef	ACCESS
			if(access(have->o_bufr,R_OK) == 0)	{
				errmsg("<orphan buffer> '%s'\n",have->o_bufr);
				return(B_ORPHAN);
				}
			else	return(B_OKAY);
#else	/*ACCESS*/
			errmsg("<orphan buffer> '%s'\n",have->o_bufr);
			return(B_ORPHAN);
#endif	/*ACCESS*/
			}
		}
	else
	if(want->o_type == 'X')	{
		if(have->o_user &&
			want->o_user != have->o_user &&
				kill(have->o_user,0) == 0)	{
				errmsg("<in use> %u %s\n",have->o_user,have->o_name);
				return(B_INUSE);
			}
		return(B_OKAY);
		}
	else	dump("isalive: bad call");
}
ORPHANS	*
havebufr(want)
ORPHANS	*want;
{
	auto	int		ix;
	auto	ORPHANS	*ox = NULL;
	for(ix = 0; ix < kenv.buffer; ix++)	{
#ifdef	DEBUG
	showlock(stderr,want);
	showlock(stderr,table[ix]);
	query(stderr);
#endif	/*DEBUG*/
		if(table[ix]->o_bnum == want->o_bnum)	{
			ox = table[ix];
			}
		}
	return( ox );
}
ORPHANS	*
haveedit(want)
ORPHANS	*want;
{
	auto	int		ix;
	auto	ORPHANS	*ox = NULL;
	for(ix = 0; ix < kenv.buffer; ix++)	{
		if(table[ix]->o_enum == want->o_enum)	{
			ox = table[ix];
			}
		}
	return( ox );
}
readtable(fp)
FILE	*fp;
{
	kenv.buffer = 0;
	while(fread((char *)&have,sizeof(ORPHANS),1,fp))	{
#ifdef	DEBUG
		orphprint(stderr,&have,"readtable");
#endif	/*DEBUG*/
		table[kenv.buffer] = (ORPHANS *) malloc(sizeof(ORPHANS));
		memcpy((char *) table[kenv.buffer],(char *) &have,sizeof(ORPHANS));
		kenv.buffer += 1;
		}
	return(kenv.buffer);
}
void
terror(ty)
{
	exit(ty);
}
main(argc,argv)
int		argc;
char	**argv;
{
	auto	char	*barf;
	auto	int		ret = 0;
	auto	int		zap = 0;
/**/
	disnme(kenv.pname = "orphans");
/**/
	barf = cmdstr(argc,argv,'f',"s");
	want.o_type = barf[0];
	barf = cmdstr(argc,argv,'p',"0");
	want.o_user = atoi(barf);
	cuserid(want.o_name);
	barf = cmdstr(argc,argv,'e',"NONE");
	strcpy(want.o_edit,barf);
	strcpy(want.o_edit,barf);
	want.o_enum = fileinode(barf);
	barf = cmdstr(argc,argv,'b',"NONE");
	strcpy(want.o_bufr,barf);
	want.o_bnum = fileinode(barf);
#ifdef	DEBUGR
	orphprint(stderr,&want,"main");
#endif	/*DEBUG*/
/**/
	kenv.ofnme = lockfile();
/**/
	ret = canweuse(&want,&have);
#ifdef	DEBUG
fprintf(stderr,"ret(%d)\n",ret);
query(stderr);
#endif	/*DEBUG*/
	exit(ret);
/**/
}
char	*
lockfile()
{
	auto	char	*pubkin = kgetenv("PUBKIN");
	auto	char	ws[FNMSIZ];
	auto	char	*mode;
	if(isnull(pubkin))	{
		errmsg("<undefined PUBKIN>\n");
		exit(FUBAR);
		}
	sprintf(ws,"%s/%s/orphans.lok",pubkin,"USAGE");
#ifdef	DEBUG
	fprintf(stderr,"lockfile(%s)\n",ws);
#endif	/*DEBUG*/
	if(access(ws,R_OK) == 0)	{
		mode = "r+";
		kenv.flags0 = OLD;
		}
	else						{
		mode = "w";
		kenv.flags0 = NEW;
		}
#ifdef	DEBUG
	fprintf(stderr,"tefopen(%s,%s)\n",ws,mode);
#endif	/*DEBUG*/
	kenv.ofptr = efopen(ws,mode);
	if(kenv.ofptr == NULL)	exit(FUBAR);
	rewind(kenv.ofptr);
	chmod(ws,perm);
	return(strsave(ws));
}
showlock(fp,orph)
FILE	*fp;
ORPHANS	*orph;
{
	fprintf(fp,"(%s) ",kenv.pname);
	fprintf(fp,"status(%c) ",orph->o_type);
	fprintf(fp,"last user(%s,%d) ",orph->o_name,orph->o_user);
	fprintf(fp,"\n");
	fprintf(fp,"(%s) ",kenv.pname);
	fprintf(fp,"i node(%u) ",orph->o_enum);
	fprintf(fp,"file(%s) ",orph->o_edit);
	fprintf(fp,"\n");
	fprintf(fp,"(%s) ",kenv.pname);
	fprintf(fp,"i node(%u) ",orph->o_bnum);
	fprintf(fp,"bufr(%s) ",orph->o_bufr);
	fprintf(fp,"\n");
	fflush(stdout);
	return(0);
}
orphprint(fp,orph,os)
FILE	*fp;
ORPHANS	*orph;
char	*os;
{
	if(!isnull(os))
	fprintf(fp,"called %s\n",os);
	fprintf(fp,"o_type %c\n",orph->o_type);
	fprintf(fp,"o_user %d\n",orph->o_user);
	fprintf(fp,"o_name %s\n",orph->o_name);
	fprintf(fp,"o_edit %s\n",orph->o_edit);
	fprintf(fp,"o_enum %u\n",orph->o_enum);
	fprintf(fp,"o_bufr %s\n",orph->o_bufr);
	fprintf(fp,"o_bnum %u\n",orph->o_bnum);
#ifdef	DEBUG
	query(fp);
#endif	/*DEBUG*/
	return;
}
scantable()
{
	auto	int		ix;
	for(ix = 0; ix < kenv.buffer; ix++)	{
		showlock(stdout,table[ix]);
		if(ix && ix % 20 == 0)	{
			fflush(stdout);
			if(query(stdout) == 'q')	break;
			}
		}
	return(kenv.buffer);
}
#ifdef	__MSDOS__
fileinode(is)
char	*is;
{
	auto	char	*hx;
	auto	long	hv = 0L;
	hx = strrchr(is,'/');
	if(hx)	hx = hx + 1;
	else	hx = is;
	while(*hx != 0)	hv += *hx++;
	return( (int) (hv % 4091L) );
}
char	*
cuserid(is)
char	*is;
{
	return((is = kgetenv("USER")) ? is : "YOU");
}
kill(a,b)
{
	return(-1);
}
#endif	/*__MSDOS__*/
