#define		DEBUG
#undef		DEBUG
/*
**	08.27.87	added redraw to $ and # operators
**	11.29.86	clearing (*) operator added
**	11.20.86	reverse < and > operators
*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include	"keyproto.h"
/**/
#ifdef		__TURBOC__
#include	"ksysgtty.h"
#else
#include	<sgtty.h>
#endif
/**/
#define		BAD_KEY		-1
#define		CBC			1
#define		LBL			2
/**/
#ifndef		KEYSIZ
#define		KEYSIZ		32
#endif
/*
**	this file contains interactive routines currently used only
**	by ked
*/
/*EXTERN*/
extern	KARD	*kd;					/* pointers to cards, field ids */
extern	KBUF	kb;						/* input line and work buffer */
/**/
static	int		pe = ZERO;				/* prompt hint switch */
static	FUNCP	act;
static	FUNCP	cln;
static	FUNCP	inf;					/* input function */
static	int		zms = 0;				/* erase error message */
static	char	*blank = "         ";	/* blank string */
static	char	ks[KEYSIZ];				/* key string */
static	int		k0;
static	int		k1;
static	char	**kp0;
static	char	**kp1;
/**/
char	*
cdel(is)	/* delete for cgdt */
char	*is;
{
	auto	int	nk;
	if((nk = badkey(is)) == BAD_KEY)	return(NULL);
	cgde(blank,blank,0);
	return(kd[nk].data = free_if(kd[nk].data));
}
char	*
cdeq(is,fd)		/* duplicate data */
char	*is;	/* left hand key */
int	fd;
{
	k0 = badkey(is);
	if(k0 == BAD_KEY)	return(NULL);
	kp0 = &kd[k0].data;
	cgdk(ks,ks+KEYSIZ-1,fd);
	if((k1 = badkey(is)) == BAD_KEY)	return(NULL);
	kp1 = &kd[k1].data;
	cgde("","",0);
	if(*kp1)	{
		free_if(*kp0);
		*kp0 = strsave(*kp1);
		cgde(blank,blank,fd);
		return(*kp0);
		}
	else	{
		errmsg("<null field> '%s'\r",ks);
		zms += 1;
		return(NULL);
		}
}
csub(is,fd)		/* make substitution */
char	*is;	/* key as string */
int	fd;
{
	auto	char	ws[FNMSIZ];
#define		NXP		4
	auto	char	*xp[NXP];
	auto	int		nc;
	auto	int		nk;
	auto	int		gl;
	auto	int		bl;
/**/
	if((nk = badkey(is)) == BAD_KEY)	return(ZERO);
/**/
	if(isnull(kd[nk].data))	{
		errmsg("<null field> '%s'\r",is);
		zms += 1;
		return(ZERO);
		}
/**/
	ws[0] = '/';
	cgdx(ws+1, ws+FNMSIZ-2, 0, kenv.folder);
/**/
	cgde("","",0);
/**/
/*
	CTEXT: Will bomb if NULL is wrong size for memory model
*/
	if(subparse(ws,(FUNCP) NULL,xp,NXP,&gl,&bl))	return(ZERO);
/**/
	nc = dsub(kb.base,kb.bmax,kd[nk].data,xp[1],gl,bl);
/**/
	if(nc >= 1)	{
		free_if(kd[nk].data);
		kd[nk].data = strsave(strcnd(kb.base));
		cdprp(nk, stdout, 'z', kenv.folder);
		}
	else	{
		errmsg("<no match>\r");
		zms += 1;
		}
	return(ZERO);
}
preh(fd)
int	fd;
{
	static	char	*hx[] = {
"=INTERACTIVE INPUT COMMANDS",
"?         display hint",
"*         clear screen",
"#         display keys",
"$         display current card",
"=",
"key<data  prepend new data",
"key>data  append new data",
"key=key   duplicate key",
"key!      delete key and data",
"key&      repeat data for last case of key",
"=",
"*         single cards are terminated by a carriage return",
"*         type a carriage return and a single . (period) to",
"*         return to ked",
"=",
"*         in overlay mode, a period or blank line returns to",
"*         ked.",
"=",
	}	;
	prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
	cbc_on(fd);
	return(fd);
}
prex(fd)
int	fd;
{
	static	char	*hx[] = {
	"=PROMPTED INPUT",
	"*",
	"*  [re]enter key and data or command(s) below.",
	"*",
	"-  back one field",
	"+  skip one field (also ,)",
	"^  back to first key",
	".  ends input (i or a)",
	"   carriage return ends card",
	"=",
	}	;
	prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
	cbc_on(fd);
	return(fd);
}
prpr(fd,pn)					/* prompt for idiots */
int	fd;
int	pn;
{
	auto	char	ws[FNMSIZ];
	if(pn >= kb.nfld)	{
		strcpy(ws,"\007(??) blank line ends card\n");
		write(fd,ws,strlen(ws));
		return(pn);
		}
	sprintf(ws,"(%s) %.32s\r",kd[pn].skey,kd[pn].label);
	write(fd,ws,strlen(ws));
	return(pn);
}
void
thnt(ks,fd)
char	*ks;
int		fd;
{
	if(pront)	{
		prex(fd);
		if(query(stdout) == 'q')	return;
		}
	preh(fd);
	return;
}
void
tkeys(ks,fd)
{
	keyslist();
	cbc_on(fd);
	return;
}
void	
tclr(ks,fd)
char	*ks;
int		fd;
{
	scr_cl(stdout);
	cbc_on(fd);
	return;
}
cgdt(fd,fw)					/* get data from terminal */
int		fd;
int		fw;
{
	auto	int		nk;
	auto	int		cx;
	auto	int		pn;
	auto	int		echo;
	auto	int		cont;
/**/
	inf = (FUNCP) keyget;
/**/
/*
**	clear is done by calling routine
*/
	if(pront && pe <= 0)	{
		pe += 1;
		prex(fd);
		}
	pn = 0;
	for( ; ; )	{
/**/
	fflush(stdout);
/**/
	echo = 0;
	cont = 1;
	cln = (FUNCP) NULL;
	act = (FUNCP) NULL;
/*
**	get "key" which may also be a control function
**	that either terminates input or calls another
**	function
*/
	if(pront)	pn = prpr(fd,pn);
/**/
	cgdk(ks,ks+KEYSIZ-1,fd);
/**/
	switch(cx = cgdz(ZERO))	{
/**/
		case	CR:
		case	LF:		if(pront)	{
							pn += 1;
							if(pn < kb.nfld)	break;
							}
						return(cgdz(cx = LF));
/**/
		case	'?':	act = (FUNCP) thnt;
						cln = (FUNCP) redraw;
		when	'+':
		case	',':	pn += 1;
		when	'-':	pn -= 1;
						pn = pn >= 0 ? pn : 0;
		when	'^':	pn = 0;
		when	'#':	act = (FUNCP) tkeys;
		case	'$':	cln = (FUNCP) redraw;
		when	'*':	act = (FUNCP) tclr;
		when	'!':	act = (FUNCP) cdel;
		when	'&':	act = (FUNCP) cdsv;
		when	'=':	act = (FUNCP) cdeq;
		when	'/':	act = (FUNCP) csub;
		when	'.':	return(cx);
		case	'>':	
		case	'<':	echo = YES;
		default:		cont = 0;
						break;
		}
	fflush(stdout);
	if(act)				(*act)(ks,fd);
	if(cln)				(*cln)(ks,fd);
	if(cont)			continue;
/*
**	if not a function, check as a key
*/
	if((nk = iskey(ks)) < 0)	{
		cgdb(ks,fd);
		continue;
		}
/**/
	sprintf(ks,"%c%-7.7s ",CR,kd[nk].skey);
/**/
	cgdp(kb.base,kb.bmax,ks,0,fw);
/**/
	kd[nk].data = strglue(cx,kd[nk].data,kb.base,kd[nk].skey);
/**/
	pn += 1;	/* advance key number for prompt */
	if(echo)	cdprp(nk,stdout,'z',kenv.folder);
	iosave(kd[nk].skey,kd[nk].data);	/* save copy */
	}
}
char	*
strglue(cx,os,is,ks)
int		cx;		/* type */
char	*os;	/* previous */
char	*is;	/* new */
char	*ks;	/* key */
{
/**/
	if(is)			strcnd(is);
/**/
	if(cx == '>')	return(strjoin(os,is," "));
	else
	if(cx == '<')	{
					if(os)	strrev(os);
					if(is)	strrev(is);
					return(strrev(strjoin(os,is," ")));
					}
/**/
	if(isnull(is))	{
		printff("\007<to null field> '%s!'\n",ks);
		return(os);
		}
/**/
	if(!isnull(os))	{
		printff("\007<redefined> '%s'\n",ks);
		}
/**/
	os = free_if(os);
/**/
	return(strsave(is));
}
char	*
cgdp(os,us,ps,fd,fw)	/* prompting routine */
char	*os;			/* out string */
char	*us;			/* upper limit to _os */
char	*ps;			/* prompt string */
int		fd;
int		fw;
{
	static	char	*ts;
	static	int		ls;
	static	char	cx;
	ls = strlen(ps);
	while( os < us )	{
	write(fd,ps,ls);
	os = cgdx(ts = os, us, fd, fw);
	cx = cgdz(ZERO);
	if(cx == '@')	cgde(os = ts, ps, fd);
	else
	if(cx == LF)	break;
	else
	if(cx == CR)	break;
	}
	return(os);
}
zpone(fd)
int		fd;
{
	write(fd,"\b \b",3);
	return(ZERO);
}
wrone(fd,cx)
int		fd;
char	cx;	/* CTEXT: must be char for SUN */
{
	write(fd,&cx,sizeof(char));
	return(cx);
}
void
cgdb(is, fd)			/* bad key message */
char	*is;
int		fd;
{
	auto	char	bs[FNMSIZ];
	auto	char	cx = ZERO;
	sprintf(bs,"\007<unknown key> '%s' <clear with CR>\007",is);
	write(fd,bs,strlen(bs));
	while(!iseol(cx))	{
		cx = (*inf)(fd);
	}	
	cgde(bs,"",fd);
	return;
}
cgdz(cx)	/* return last character read */
int		cx;
{
	static	int		cz = ZERO;
#ifdef	DEBUG
	printf("%o = cgdz(%o)\n",cz,cx);
#endif	DEBUG
	return( (cx == ZERO) ? cz : (cz = cx) );
}
char	*
cgdk(os,us,fd)				/* get key from terminal */
char	*os;
char	*us;
{
	auto	char	*osx = os;
	auto	char	*usx = us;
	static	char	cx;
	*osx = ZERO;
	for( ; ; )	{
	cx = (*inf)(fd);
	if(zms)	{
		cgde("","",fd);
		zms = 0;
		}
	if(isprint(cx) || isspace(cx))	wrone(fd,cx);
	cgdz(cx);
	if(isalnum(cx) && osx < usx)	*osx++ = cx;
	else
	if(cx == '\100')	{
		*osx = ZERO;
		cgde(os,"",fd);
		osx = os;
		}
	else
	if(cx == '\b')	{
		if(osx > os)	{
			zpone(fd);
			*--osx = ZERO;
			}
		}
	else			break;
	}
	*osx = ZERO;
	cgde(os,"",fd);
	return(os);
}
char	*
cdsv(is,fd)		/* fill in key from saved, if any */
char	*is;	/* key as string */
int		fd;		/* not used */
{
	auto	char	*dt;
/**/
	if((k1 = badkey(is)) == BAD_KEY)	return(NULL);
/**/
	cgde("","",0);
/**/
	if(!(dt = iopull(is)))	return(dt);
/**/
	kp1 = &kd[k1].data;
	free_if(*kp1);
/**/
	if(dt)	{
		*kp1 = strsave(dt);
		cdprp(k1,stdout,'z',kenv.folder);
		}
/**/
	return(dt);
}
void
cgde(is, ps, fd)		/* erase a line */
char	*is;			
char	*ps;			/* prompt string */
int		fd;
{
/*
**	if terminal allows a line erase, do it;
**	otherwise back to the beginning of the line;
**	write a @ and back up once again
*/
	if(scr_ce(stdout))	return;
	else				erase(is,stdout);
	write(fd,"\015@\015",3);
	return;
}
char	*
cgdx(os,us,fd,fw)	/* read line in cbreak */
char	*os;		/* out string */
char	*us;		/* upper limit to _os */
int		fd;			/* file descriptor */
int		fw;			/* fold width */
{
	auto	int		hp = ZERO;	/* horizontal position */
	auto	char	*osx = os;
	auto	char	*usx = us;
	auto	int		lo = YES;
	auto	int		lc = ZERO;	/* last character */
	auto	int		cx;
	while(lo && osx < usx)	{
/**/
		cx = (*inf)(fd);
/**/
		if(cx == '\b')	{
			if(hp >= 1)	{
				zpone(fd);
				*--osx = lc = ZERO;
				--hp;
				}
			else	{
				wrone(fd,'\007');
				}
			}
		else
		if(cx == '\100')			{
			if(lc == ESC)	{
				zpone(fd);
				osx[-1] = lc = wrone(fd,cx);
				}
			else	{
				cgdz('\100');
				lo = NO;
				}
			}
		else
		if(iseol(cx) || (cx == ' ' && hp >= fw))	{
			*osx++ = ' ';
			wrone(fd,LF);
			cgdz(cx);
			lo = NO;
			}
		else	{
			if(cx < ' ' || cx > '~')	{
				wrone(fd,'\007');
				cx = ' ';
				}
			*osx++ = lc = wrone(fd,cx);
			hp += 1;
			}
	}
	if(osx >= usx)	errmsg("<overflow>\n");
	*osx = ZERO;
	return(osx);
}
void
redraw(ks,fd)
char	*ks;
int		fd;
{
	if(kenv.leisur & DA)	scr_cl(stdout);
	twrcd(stdout,'f',kenv.folder);
	cbc_on(fd);
}
