#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
#undef		XASCII
#define		XASCII
#define		TIGHT
#ifndef		ZERO
#define		ZERO	0
#endif
/*
**	coding scheme
**
**	^W	indicates a word of the length given by the next
**		character
**	^?	length of word (a single byte)
**	abc	the word itself
**	^S	the end of the word
**
**	^W^C^Rabc^S
**
**	indicates a word of three printing characters in ^R (roman)
**	type
**
**	after processing by sentence(), the size byte (following ^W)
**	indicates the amount of space to be inserted.  initially this
**	is 1 or 2 depending on whether a sentence break has been
**	seen.  if justification is used, the value of this byte may
**	be further modified.
*/
/*
**	86:10:10	simplified sentence routine
**				simplified break routine
**	87:04:09	TIGHT to control spacing
*/
/*EXTERNAL*/
/*
*/
xad(nv,is)              /* adjust (justify)? */
char    *is;
{
	if(x[nv].br >= 1 && x[nv].osx > x[nv].os)   xbr(nv,is);
	x[nv].br = 0;
	return(x[nv].ad = setvar(nv,is,ABSO,x[nv].ad,1));
}
xfi(nv,is)              /* fill ? */
char    *is;
{
	if(x[nv].br >= 1 && x[nv].osx > x[nv].os)   xbr(nv,is);
	x[nv].br = 0;
	return(x[nv].fi = setvar(nv,is,ABSO,x[nv].fi,1));
}
xbr(nv,is)              /* do breaks */
char    *is;
{
	x[nv].br = 0;
	if(x[nv].hp >= 1)           {
		sentence(x[nv].os,0);
		txtwrt(nv,x[nv].os);
		return(zrs(nv,is));
		}
	else    return(0);
}
zrs(nv,is)              /* line resets */
char    *is;
{
	x[nv].osx = x[nv].os;
	*x[nv].osx = ZERO;
	x[nv].ti = x[nv].wc = x[nv].hp = 0;
	return(0);
}
nofill(nv,is)
char    *is;
{
	REG     unsigned	char    *isx = is;
	REG     unsigned	char    *osx = x[nv].osx;
	REG     			int     hpx = x[nv].hp; 
	REG     unsigned	char    *osu = x[nv].osu;
/*
**  no fill writes unless a \c is encountered
*/
	while(osx < osu && *isx != ZERO && *isx != ITP) {
		hpx += pwc(*isx);
		*osx++ = *isx++;
	}
	if(*isx == ITP)	*osx++ = *isx;
	*osx   = ZERO;
	x[nv].osx = osx;
	x[nv].hp = hpx;
	if(*isx == ITP)	return(0);
	else			return(txtwrt(nv,is));
}
filler(nv,is)
char    *is;
{
	REG     char    *isx = NULL;
	REG     char    *osx = NULL;
	REG	    char    *osu = NULL;
	auto    char    *bsx = NULL;
	auto    char    *wsx = NULL;
	auto    char    *tsx = NULL;
	auto	int     nl = 0;
	auto	int     ne = 0;
	auto	int     xf = 0;
/*
*/
	isx = is;
	osu = x[nv].osu;
	osx = x[nv].osx;
	nl = x[nv].ll - x[nv].in - x[nv].ti;
/*
*/
	while(osx < osu && isx && *isx != ZERO)	{
/*
*/
	isx = wordcopy(osx,osu,bsx = isx);
/*
*/
	if((osx[WLEN] + x[nv].hp) > nl) {
		ne = nl - x[nv].hp;
		if(x[nv].hy && osx[WLEN] >= 6 && ne >= 3)   {
			*osx = ZERO;
			isx = hypher(nv,osx,osu,bsx,ne,x[nv].hy);
			bsx = isx != NULL ? isx : bsx;
			}
/*
*/
		osx = x[nv].osx;
		while(*osx != STOP) osx -= 1;
		*osx = ZERO;
		x[nv].hp -= 1;
/*
*/
		if(x[nv].ad == 0)   sentence(x[nv].os,nl-x[nv].hp);
		else    			juster(x[nv].os,nl,x[nv].hp,x[nv].wc-1);
/*
*/
		xf = get_font(x[nv].os);	/* get font */
		txtwrt(nv,x[nv].os);
		nl = x[nv].ll - x[nv].in - x[nv].ti;
		osx = x[nv].os;     		/* reset the buffer */
		isx = bsx;          		/* reread the last word */
		*osx++ = xf;				/* set for next line */
		}
/*
*/
	else	{
		x[nv].hp += osx[WLEN];
		tsx = osx;
		wsx = &osx[WOFF];
		osx += osx[WOFF];
		*wsx = WORD;
		if(osx[-1] == ITP)  {
			osx = strkat(tsx,osu,tsx+2) -1;
			}
		else
		if(osx[-1] == STOP) {
			x[nv].hp += 1;
			x[nv].wc += 1;
			}
		*osx = ZERO;
		x[nv].osx = osx;
		}
	}
	return(x[nv].hp);
}
char	*
hypher(nv,os,us,is,ne,hy)
char	*os;
char	*us;
char	*is;
{
	auto    char    *isx = is;
	auto    char    *wsx = os;
	isx = hyphen(wsx = os,us,is,ne,hy);
	if(isx == NULL) return(NULL);
	x[nv].osx += wsx[WOFF];
	x[nv].hp += wsx[WLEN] + 1;
	x[nv].wc += 1;
	wsx[WOFF] = WORD;
	return(isx);
}
char    *
juster(is,lw,lh,sc)
char    *is;	/* input line */
int     lw;		/* desired line width */
int     lh;		/* current line width */
int     sc;		/* slots */
{
	static  int     rev = 1;
	REG     char    *isx = is;
	REG     int     need = lw - lh;
	REG     int     plus;
	REG     int     slot = sc;
	if(slot <= 0)	return(is);		/* hopeless */
	rev = rev ? 0 : 1;
	need = need >= 1 ? need : 0;
	need = sentence(is,need);
	plus = need;
	if(rev) plus = need + plus % slot;
	while(*isx != ZERO)
	if(*isx == WORD)    {
/*XXX*/
		isx[1] += plus / slot;
		plus = need + plus % slot;
		isx += 2;
		}
	else    ++isx;
	return(is);
}
sentence(is,ne)
char    *is;
int     ne;
{
	REG     char    *isx = is;
	auto	int		sp = 1;
/**/
	while(*isx != ZERO)
	if(*isx == WORD)	{
		isx[0] = isx[1] = STOP;
		break;
		}
	else	isx += 1;
/**/
	while(*isx != ZERO)
	switch(*isx)	{
		case	WORD:
				isx[1] = (char) sp;
				ne = (--sp) ? (--ne) : ne;
				isx += 2;
				sp = 1;
				break;
		case	'.':
		case	'?':
		case	'!':
				if(ne >= 1 &&
					(isx[2] == WORD || isx[1] == '"'))	sp = 2;
		default:		
				isx += 1;
				break;
		}
	return(ne);
}
get_font(is)
char	*is;
{
	REG		char	*isx = is;
	REG		int		xf = ZERO;
	while(*isx != ZERO)
	if(*isx >= ' ' && *isx <= '~')	++isx;
	else
	if(*isx == WORD)				isx += 2;
	else
	if(isfont(*isx))				xf = *isx++;
	else							++isx;
	if(xf == ZERO)	{
		errmsg("get_font: <no font>\n");
		prtesc(stdout,is,"get_font");
		xf = FOR;
		}
	return(xf);
}
char    *
wordcopy(os,us,is)
char    *os, *us, *is;
{
	static	char	*here = "wordcopy";
	REG     unsigned	char    *osx = os + 2;
	REG     unsigned	char    *usx = us;
	REG     unsigned	char    *isx = is;
	os[WOFF] = os[WLEN] = 0;
/**/
	while(isspace(*isx))    ++isx;
	if(*isx == ZERO)        return(NULL);
/**/
	*osx = ZERO;
	while(osx < usx)
#ifdef	XASCII
	if(*isx > ' ' )	{
		os[WLEN] += 1;
		*osx++ = *isx++;
		}
	else
	if(*isx == '\b')    {
		os[WLEN] -= 1;
		*osx++ = *isx++;
		}
#else 	/*XASCII*/
	if(*isx > ' ' && *isx <= '~')   {
		os[WLEN] += pwc(*isx);
		*osx++ = *isx++;
		}
	else
	if(*isx == '\b')    {
		os[WLEN] += pwc(*isx);
		*osx++ = *isx++;
		}
#endif 	/*XASCII*/
	else
	if(*isx == ' ' || *isx == ZERO)     {
		*osx++ = STOP;
		*osx = ZERO;
		os[WOFF] = osx - os;
		while(*isx == ' ')		++isx;
		return(isx);
		}
	else
	if(*isx == ITP) {
		*osx++ = *isx++;
		*osx = ZERO;
		os[WOFF] = osx - os;
		while(*isx != ZERO) ++isx;
		return(isx);
		}
	else
	if(*isx == ZSP) {
		os[WLEN] += pwc(*isx);
		*osx++ = *isx++;
		}
	else
	if(*isx > ZERO && *isx < ' ')   {
		*osx++ = *isx++;
	}
	else    {
		errmsg("%s <unknown char> '%c' %03o\n",here,*isx,*isx);
		errmsg("%s <bad line> '%s'\n",here,is);
		dump(here);
	}
	dump(here);
	return(NULL);
}
