/*DOSLIB*/
/*UNXLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<signal.h>
#ifdef		MSDOS
#include	<io.h>
#include	<dir.h>
#include	<dos.h>
#endif		/*MSDOS*/
/**/
/*EXTERN*/
#ifdef	CAN_PROTO
extern	int		inset(FILE *);
extern	int		xinset(int, char**);
extern	long	textlength(char *);
extern	long 	checkcrc(int, char *);
#else	/*CAN_PROTO*/
extern	int		inset();
extern	int		xinset();
extern	long	textlength();
extern	long 	checkcrc();
#endif	/*CAN_PROTO*/
/*GLOBAL*/
/**/
KENV	kenv;
/*
*/
/*
**      compare a list of files from ktree;
**      the file(s) should be in the form
**
**      name number
**
**      where number may be mtime (-m) or size (-s)
**
**      output indicates the relation between the file
**      listed in the input and those found on the local
**      file system.
*/
#define         MTIME   1
#define         FSIZE   2
#define         CHECK   4
/*GLOBAL*/
char		*ifn;
char		*base;
char    ls[BUFSIZ];
char    fn[BUFSIZ];
char	cd[FNMSIZ];
void
terror(ty)
int	ty;
{
	chdir(cd);
	exit(ty);
}
main(argc,argv)
int     argc;
char    *argv[];
{
	kenv.dosdos = isdos();
	disnme(kenv.pname = "inset");
	exit(cmdxrc(argc,argv,xinset,"inset.xrc"));
	return( 0 );	/* LINT */
}
xinset(argc,argv)
int     argc;
char    *argv[];
{
/**/
	if(kenv.dosdos)	cmdxpd(argc,argv);
	else			telluser(kenv.pname);
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/**/
	if(kenv.dosdos)	{
		setcbrk(YES);
		getcwd(cd,FNMSIZ);
		}
	signal(SIGINT,terror);
/**/
	if(cmdnum(argc,argv,'h',0,DA))	exit(hint(ZERO));
/**/
	base = cmdstr(argc,argv,'d',NULL);
	kenv.flags0 = cmdnum(argc,argv,'t',DA,DA);
	kenv.flags1 = cmdnum(argc,argv,'u',kenv.dosdos,kenv.dosdos);
	dolist(argc,argv,inset);
	exit(0);
	return(0);	/* LINT */
}
inset(fp)
FILE	*fp;
{
	auto	long	lsize;
	auto	long	rsize;
	auto	long	lcrc;
	auto	long	rcrc = 0L;
	auto	long	lmtime;
	auto	long	rmtime;
	auto	char	sizetype = 0;
	auto	char	timetype = 0;
	auto	char	crctype = 0;
	struct	stat	sb;
/**/
	while(fgetlf(ls,ls+BUFSIZ-1,fp))	{
/**/
        sscanf(ls,"%s %ld%c %ld%c %ld%c",fn,&rmtime,
			&timetype,&rsize,&sizetype,&rcrc,&crctype);
/**/
		if(access(fn,0) == 0)	{	/* check for existence */
			stat(fn,&sb);
			lsize = sb.st_size;
			if(kenv.flags1) 	lmtime = ktimedtu(sb.st_mtime);
			else
			if(timetype == 'u') lmtime = ktimedtu(sb.st_mtime);
			else
			if(timetype == 'm') lmtime = sb.st_mtime;
			else 				lmtime = sb.st_mtime;
			}
		else	{
			fputs("! ",stdout);
			fputs("   ",stdout);
			if(rcrc)	fputs("  ",stdout);
			fputs(fn,stdout);
			fputs("\n",stdout);
			continue;
			}
/**/
		if(lmtime == rmtime && lsize == rsize)	{
			continue;
			}
/**/
		if(lmtime > rmtime)	fputs("Mm",stdout);
		else
		if(lmtime < rmtime) fputs("mM",stdout);
		else				fputs("==",stdout);
/**/
		if(sizetype == 't') lsize = textlength(fn);
		else
		if(sizetype == 's') lsize = sb.st_size;
		else 				lsize = sb.st_size;
/**/
		if(lsize > rsize)	fputs("Ss",stdout);
		else
		if(lsize < rsize) 	fputs("sS",stdout);
		else				fputs("==",stdout);
/**/
		if(rcrc && crctype)			{	/* crc check */
		lcrc = checkcrc(crctype,fn);
		if(lcrc > rcrc)		fputs("Cc",stdout);
		else
		if(lcrc < rcrc) 	fputs("cC",stdout);
		else				fputs("==",stdout);
		}
/**/
		fputs(" ",stdout);
		fputs(fn,stdout);
		fputs("\n",stdout);
        }
/**/
	return(ZERO);
}
hint(ty)
int		ty;
{
	static	char	*hx[] = {
"=inset [-options] [file]",
"*",
"*      reads a file prepared with",
"*      ktree . -fo n[m|u][s|t][c|c]",
"*      and indicates the relation between the listed files",
"*      and those found on the local system.",
"*",
"=OUTPUT",
"-?     corresponding ktree flag (not inset option)",
"-u     modification time in common UNIX format",
"*      default on under MSDOS.  turn off with -u0",
"*",
"*      Mm local file newer",
"*      mM remote file newer",
"-s     size (binary) in characters",
"-t     size (text) in characters w/o CR",
"*      Ss local file larger",
"*      sS remote file larger",
"-c     text (line by line) checksums",
"-C     binary checksums",
"*      Cc local file larger",
"*      cC remote file larger",
"*      !  no local file",
"*",
"*",
"=BUGS",
"*      time comparisons between MSDOS and **IX are seldom",
"*      reliable",
"*      the t option is slow",
"=",
}	;
	prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
	return(ty);
}
#ifndef	MSDOS
long
ktimedtu(tm)
long	tm;
{
	return(tm);
}
#endif	/*MSDOS*/
