/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
/*EXTERN*/
extern	KENV	kenv;
/*STATIC*/
static	char	*lcmd = NULL;
static	char	*ccmd = NULL;
static	short	echoing = 1;
#ifdef	MSDOS
static	short	echosize = FNMSIZ;
#else	/*MSDOS*/
static	short	echosize = BUFSIZ;
#endif	/*MSDOS*/
/**/
echosz(ty)		/* set command size */
int		ty;
{
	if(ty == 0) ty = kenv.dosdos ? FNMSIZ : BUFSIZ;
	echosize ^= ty;
	ty ^= echosize;
	echosize ^= ty;
	return(ty);
}
echosh(ty)			/* set echoing, return state */
int		ty;
{
	echoing ^= ty;
	ty ^= echoing;
	echoing ^= ty;
	return(ty);
}
/**/
doshell(is,f1,f2)
char	*is;		/* input string */
char	*f1;		/* file for % sub */
char	*f2;		/* file for # sub */
{
    return(zdoshell(is,f1,f2));
}
zdoshell(is,f1,f2)
char	*is;		/* input string */
char	*f1;		/* file for % sub */
char	*f2;		/* file for # sub */
{
	auto	short	echo = NO;
	auto	char	*ws, *wsx, *wsu;
/**/
	ccmd = ws = wsx = free_if(ccmd);
	ccmd = ws = wsx = emalloc(echosize,"zdoshell");
	wsu = ws + echosize - 2;
/**/
	strkat(ws, wsu, is);
/**/
	while(wsx < wsu && *wsx != ZERO)
	switch(*wsx)	{
	case	ESC:	if(wsx[1] == '!' ||
						wsx[1] == '%' ||
							wsx[1] == '#')
								wsx = strcpy(wsx,wsx+1) + 1;
					if(*wsx != ZERO)	wsx += 1;
	when	'%':	if(isnull(f1))		return(noname('%'));
					else	{
						echo = echoing & YES;
						wsx = strsub(wsx,wsx+1,wsu,f1);
						}
	when	'#':	if(isnull(f2))		return(noname('#'));
					else	{
						echo = echoing & YES;
						wsx = strsub(wsx,wsx+1,wsu,f2);
						}
	when	'!':	if(isnull(lcmd))	return(noname('!'));
					else	{
						echo = echoing & YES;
						wsx = strsub(wsx,wsx+1,wsu,lcmd);
						}
					break;
	default:		wsx += 1;
	}
/**/
	if(wsx >= wsu)	{
		wsx[-1] = 0;
		errmsg("doshell <overflow>\n");
		fputs(ws,stderr);
		fputs("\n",stderr);
		ccmd = free_if(ccmd);
		fubar(FUBAR);
		}
/**/
	lcmd = free_if(lcmd);
/**/
	if(echo && isatty(1))	{
		fputc('!',stdout);
		puts(ws);
		fflush(stdout);
		}
/**/
	lcmd = strsave(ws);
	ccmd = free_if(ccmd);
/**/
	return(system(lcmd));
}
noname(cx)
int	cx;
{
	errmsg("doshell <nothing to sub for> '%c'\n",cx);
	ccmd = free_if(ccmd);
	return(1);
}
#ifdef      TEST
fubar()
{
	printff("DAMN!");
	return(ZERO);
}
KENV	kenv;
void
terror(ty)
int		ty;
{
	exit(ty);
}
main()
{
	auto	char    ls[BUFSIZ];
	auto	char	f1[BUFSIZ];
	auto	char	f2[BUFSIZ];
	auto	short	size = 0;
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])
	{
	case    'e':    echosh(1);break;
	case	'S':	size = echosz(atoi(ls+1));
					printf("%d\n",size);
					break;
	case    'E':    echosh(0);break;
	case    '!':    doshell(ls+1,f1,f2);break;
	case    '%':    strcpy(f1,ls+1); break;
	case    '#':    strcpy(f2,ls+1);break;
	default:        puts("??");break;
	}
	exit(0);
}
#endif
