/*UNXLIB*/
/*DOSLIB*/
#define	DEBUG
#undef	DEBUG
/*
**      these routines provide some common screen functions without
**      going through the slow process of reading /etc/termcap
**      additional specifications can be added as needed
**      scr_bs is sensitive to the INSTALLATION
*/
#include        "ksysdefs.h"
#include        "ksysvtyp.h"
#include	"ksysprot.h"
/**/
char	*cltt = "";
char	*clce = "";
char	*clcl = "";
char	*clso = "";
char	*clse = "";
char	*clbs = "";
char	*clho = "";
/*EXTERNAL*/
extern  KENV    kenv;
/**/
static  int   	term_set = 0;
static  FILE    *lfp = NULL;
static  int   	wasaterm = 0;
#ifdef	CAN_PROTO
static	int		isaterm(FILE *);
#else	/*CAN_PROTO*/
static	int		isaterm();
#endif	/*CAN_PROTO*/
/**/
/**/
erase(is,fp)		/* erase string is */
FILE    *fp;
char    *is;
{
	fputc(CR,fp);
/**/
	if(scr_ce(fp))	return(1);
/**/
	while(*is++ != ZERO)    fputs(" ",fp);
	fputc(CR,fp);
/**/
	return(ZERO);
}
static
isaterm(fp)
FILE    *fp;
{
/*
**      this is to avoid an expensive call to isatty for each call of
**      scr_??() routines; it will fail if freopen is used on an
**      output file
*/
#ifdef	DEBUG
fprintf(stderr,"isaterm(%u) lfp (%u)\n",fp,lfp);
#endif	DEBUG
        if(fp != lfp)   {
                lfp = fp;
                wasaterm = isatty(fileno(lfp));
                }
#ifdef	DEBUG
fprintf(stderr,"wasaterm = %u\n",wasaterm);
#endif	DEBUG
        return(wasaterm);
}
char    *
ffputs(is,fp)
char    *is;
FILE    *fp;
{
		if(is && isaterm(fp))	{
			fputs(is,fp);
			fflush(fp);
			return(is);
			}
		else	{
			return(NULL);
			}
}
/**/
static  struct  TS  {
        char    *tt;    /* name */
        char    *ce;    /* clear to end of line */
        char    *cl;    /* clear screen */
        char    *so;    /* standout */
        char    *se;    /* !standout */
        char    *bs;    /* move to bottom of screen */
        char    *ho;    /* home */
}   tr[] = {
"vt100",
"\015\033[2K","\033[0;0H\033[2J","\033[1m","\033[0m",
	"\033[22;0H","\033[0;0H",
"att6310",
"\015\033[2K","\033[0;0H\033[2J","\033[1m","\033[0m",
	"\033[22;0H","\033[0;0H",
"ansi",
"\015\033[2K","\033[0;0H\033[2J","\033[1m","\033[0m",
	"\033[22;0H","\033[0;0H",
"m2vt52",
"\015\033K","\033H\033J","\0338","\0339","\033Y54 1",
	"\033Y32 1",
"h9",
"\033K","\033E","\033p","\033q","","",
"vi920c",
"\033T","\032","\033j","\033k","","",
"adm3a",
"\033T","\032","\033):","\033(:","","",
"ibmpc",
"\015\033[2K","\014","\033[7m","\033[0m","\033[22;0H","\033[0;0H",
};
static  struct  TS      *tx = NULL;
termcap()               /* set terminal capabilities */
{
        auto    char    *term = kgetenv("TERM");
        auto    int     i;
#ifdef	DEBUG
fprintf(stderr,"termcap: term(%s)\n",term);
#endif	DEBUG
        if(isnull(term))	return(term_set = 0);
        for(i = 0; i < sizeof(tr)/sizeof(struct TS); i++)       {
			if(strcmp(tr[i].tt,term) == 0)  {
				tx = tr + i;
				cltt = tx->tt;
				clce = tx->ce;
				clcl = tx->cl;
				clso = tx->so;
				clse = tx->se;
				clbs = tx->bs;
				clho = tx->ho;
				break;
				}
        }
        return(term_set = 1);
}
char	*
scr_ho(fp)              /* move to bottom of screen */
FILE    *fp;
{
		if(!tx)	return(NULL);
		return(ffputs(tx->ho,fp));
}
char	*
scr_bs(fp)              /* move to bottom of screen */
FILE    *fp;
{
		if(!tx)	return(NULL);
        return(ffputs(tx->bs,fp));
}
char	*
scr_se(fp)              /* send standout end code */
FILE    *fp;
{
		if(!tx)	return(NULL);
        return(ffputs(tx->se,fp));
}
char	*
scr_so(fp)              /* send standout code */
FILE    *fp;
{
		if(!tx)	return(NULL);
        return(ffputs(tx->so,fp));
}
char	*
scr_ce(fp)      /* erase to end of line */
FILE    *fp;
{
		if(!tx)	return(NULL);
        return(ffputs(tx->ce,fp));
}
char	*
scr_cl(fp)      /* clear screen */
FILE    *fp;
{
		if(!tx)	return(NULL);
        return(ffputs(tx->cl,fp));
}
/**/
#ifdef  TEST
KENV    kenv;
hint()
{
	static	char	*hx[] = {
	"#              initialize",
	"!cmd           doshell(cmd)",
	"B              base line cursor",
	"E              scr_ce",
	"H              home cursor",
	"L              scr_cl",
	"Zstring        erase string",
	"o              emphasis on",
	"e              emphasis end",
	"S              is stdout a term",
	"F              is stderr a term",
	"I              is stdin a term",
	}	;
	prhint(hx,sizeof(hx)/sizeof(char**),ZERO,ZERO);
	return(ZERO);
}
argprt(argc,argv,argp)
int	argc;
char	**argv;
char	**argp;
{
	while(*argp)	puts(*argp++);
	return(ZERO);
}
main(argc,argv,argp)
int	argc;
char	*argv[];
char	*argp[];
{
        auto    char    ls[BUFSIZ];
        disnme(kenv.pname = "screen");
        kenv.dosdos = isdos();
        kenv.diagno = DA;
	hint();
        while(putchar('?'),fflush(stdout),gets(ls))
        switch(ls[0])   {
        case    'q':    exit(0);
	when	'+':	argprt(argc,argv,argp);
	when	'Z':	printf("\n%s",ls+1);
			erase(ls+1,stdout);
        when    '#':    termcap();
        		disnme(kenv.pname = "tester");
        when    '!':    doshell(ls+1,NULL,NULL);
        when    'H':    scr_ho(stdout);
        when    'B':    scr_bs(stdout);
        when    'E':    fputs("TEST LINE",stdout);
			scr_ce(stdout);
        when    'L':    scr_cl(stdout);
        when    'e':    scr_se(stdout);
			puts(ls+1);
        when    'o':    scr_so(stdout);
			break;
	when	'I':	isaterm(stdin);
	when	'F':	isaterm(stderr);
	when	'S':	isaterm(stdout);
			break;
	case	'?':	hint();
        default:        puts(ls);
                        break;
        }
}
#endif
