/*
	the mks toolkit shell does not properly handle
	sh -c prog arg0 arg1 argn
	the command is converted to sh -c 'prog arg0 arg1 argn'

	getcwd is used for return to the current directory.

*/
/*UNXLIB*/
/*DOSLIB*/
#ifdef		MSDOS
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	<process.h>
#include	<io.h>
/*EXTERN*/
extern		KENV	kenv;
/**/
#ifndef		__TURBOC__
#define		const	/**/
#endif
/**/
static		char	*flc = "-c";
/**/
void
toexit()
{
	fprintf(stderr,"<exit to return from shell>\n");
	return;
}
system(is)
const	char	*is;
{
	auto	char	*shell;
	auto	char	*sname;
	auto	int		ret;
	auto	char	cwd[FNMSIZ];
	auto	char	sc[3];
	sc[0] = switchar(0);
	sc[1] = 'c';
	sc[2] = 0;
/**/
	shell = kgetenv("SHELL");
	if(shell == NULL)	{
		errmsg("system: <!cmd requires SHELL in environment>\n");
		fubar(FUBAR);
		}
/**/
	strlwr(shell);
	strxty(shell,'\\','/');
/**/
	if(access(shell,05))	{
		errmsg("system <cannot find> '%s'\n",shell);
		return(-1);
		}
/**/
	sname = strrchr(shell,'/');
	if(sname != NULL)	sname += 1;
	else				sname = shell;
/**/
	getcwd(cwd,FNMSIZ);
/**/
	if(stricmp(sname,"sh.exe") == 0)			{
		if(isnull(is))	{
			toexit();
			sc[1] = 'i';
			ret = spawnl(P_WAIT,shell,sname,sc,NULL);
			}
		else	{
			ret = spawnl(P_WAIT,shell,sname,sc,"'",is,"'",NULL);
			}
		}
	else
	if(stricmp(sname,"command.com") == 0)	{
		if(isnull(is))	{
			toexit();
			ret = spawnl(P_WAIT,shell,sname,NULL);
			}
		else	{
/*
	apparently command.com barfs on the form -c 'string'
*/
			ret = spawnl(P_WAIT,shell,sname,sc,is,NULL);
			/* ret = spawnl(P_WAIT,shell,sname,sc,"'",is,"'",NULL); */
			}
		}
	else	{
		errmsg("system: <unknown SHELL> '%s'\n",sname);
		fubar(FUBAR);
		}
/**/
	if(ret < 0)	{
		prterr(shell);
		}
/**/
	chdir(cwd);
/**/
	return(ret);
}
#include	<dos.h>
switchar(cx)
int	cx;
{
	union	REGS	regs;
	auto	int	pc;
/*	
*	change switch character or return previous
*
*	Alan Holub, C CHEST, p. 146.
*/
/*	get previous */
	regs.x.dx = cx;
	regs.x.ax = 0x3700;
	intdos(&regs,&regs);
	pc = regs.h.dl;
/*  set current */
	if(cx)	{
		regs.x.dx = cx;
		regs.x.ax = 0x3701;
		intdos(&regs,&regs);
		}
/*	return previous */
	return(pc);
}
#else	MSDOS
switchar(cx)
int	cx;
{
	return('-');
}
#endif	MSDOS
#ifdef	TEST
KENV	kenv;
void
terror(ty)
int		ty;
{
	exit(ty);
	return;
}
main()
{
	auto	char	ws[FNMSIZ];
	auto	char	ls[FNMSIZ];
	disnme(kenv.pname = "system");
	kenv.dosdos = isdos();
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])	{
		case	'e':	putenv(strsave(strcnd(ls+1)));break;
		case	'g':	puts(kgetenv(strcnd(ls+1)));break;
		case	's':	printf("switch(%c)\n",switchar(ls[1]));
						break;
		case    '!':    system(ls+1); break;
		case	'q':	exit(0); break;
		case	'?':
		default:		puts("!cmd");
						puts("eNAME=string set environment var");
						puts("gNAME get environment var");
						puts("q[uit]");
						puts("s[witchchar]");
						puts("?");
		}
}
#endif
