#include	"pdtar.h"
#include	"pdproto.h"
/**/
long
from_oct(fw, is)
int    fw;	/* field width */
char  *is;	/* character string */
{
	auto	long   value;
/**/
	while (isspace(*is)) {	/* Skip spaces */
		is++;
		if(--fw <= 0) return(0L);	/* EHK */
	}
/**/
	value = 0;
/**/
	while (fw > 0 && isodigit(*is)) {
		/* Scan til nonoctal */
		value = (value << 3) | (*is++ - '0');
		--fw;
	}
/**/
	if(fw > 0 && *is && !isspace(*is)) return(0L);	/* EHK */
/**/
	return(value);
}
/*
* Quick and dirty octal conversion.
* Converts long "value" into a "digs"-digit field at "where",
* including a trailing space and room for a null.  "digs"==3 means
* 1 digit, a space, and room for a null.
*
* We assume the trailing null is already there and don't fill it in.
* This fact is used by start_header and finish_header, so don't change it!
*
* This should be equivalent to:
*	(void) sprintf(where, "%*lo ", digs-2, value);
* except that sprintf fills in the trailing null and we don't.
*/
void
to_oct(value, digs, where)
long   value;
int    digs;
char  *where;
{
	--digs;						/* Trailing null slot is left alone */
	where[--digs] = ' ';		/* Put in the space, though */
	/* Produce the digits -- at least one */
	do
	{
		where[--digs] = '0' + (value & 7);		/* one octal digit */
		value >>= 3;
	} while (digs > 0 && value != 0);
	/* Leading spaces, if necessary */
	while (digs > 0)
		where[--digs] = ' ';
}
RECORD	*
encode(ty,f_name,l_name,phstat,head)
int		ty;
char	*f_name;
char	*l_name;
STAT	*phstat;
RECORD	*head;
{
/**/
	memset(head->charptr, 0, BLKSIZ);
/**/
	if(codename('F',head,f_name))	abort();
/**/
	/* if(ty == 'L')	phstat->st_size = 0L; */
/**/
#ifdef MSDOS
	if(oswitch.usemask)	phstat->st_mode |= DOSUMASK;
	to_oct((long)phstat->st_mode,8,head->header.mode);
#else
	to_oct((long)phstat->st_mode,8,head->header.mode);
#endif
	to_oct((long) phstat->st_uid, 8, head->header.uid);
	to_oct((long) phstat->st_gid, 8, head->header.gid);
	to_oct((long) phstat->st_size, 12, head->header.size);
/*
|	time should have been converted earlier by doaseg()
*/
	to_oct((long) phstat->st_mtime, 13, head->header.mtime); /* 13 ? */
/**/
/*
	Xenix doc claims linkflag contains number of links.  this is
	apparently not the case.
*/
	if(ty == 'L')	{
		head->header.linkflag = '1';
		if(codename(ty,head,l_name))	abort();
		}
/**/
	to_oct((long) device.extno, 4, head->header.extno);
	to_oct((long) device.extotal, 4, head->header.extotal);
	to_oct((long) device.efsize, 12, head->header.efsize);	/* 13 ? */
	return(0);
}
codename(ty,head,name)
int		ty;
RECORD	*head;
char	*name;
{
	auto	char	*os;
	if(ty == 'F') 	os = head->header.name;
	else
	if(ty == 'L')	os = head->header.linkname;
	strcpy(os,name);
	if(os[NAMSIZ - 1]) {
		fprintf(stderr, "%s: name too long\n",os);
		return(1);
		}
	return(0);
}
RECORD	*
chkhead(head)		/* make check sum for head */
RECORD	*head;
{
	auto	int		i;
	auto	char	*p;
	auto	long	sum = 0L;
/**/
	memcpy(head->header.chksum, CHKBLANKS, sizeof(head->header.chksum));
/**/
	p = head->charptr;
/**/
	for (i = sizeof(*head); --i >= 0;) sum += 0xFF & *p++;
/**/
/*
* Fill in the checksum field.  It's formatted differently from the other
* fields:  it has [6] digits, a null, then a space -- rather than
* digits, a space, then a null. We use to_oct then write the null in
* over to_oct's space. The final space is already there, from
* checksumming, and to_oct doesn't modify it. 
*
* This is a fast way to do: (void) sprintf(head->header.chksum, "%6o",
* sum); 
*/
	to_oct((long) sum, 8, head->header.chksum);
/**/
	head->header.chksum[6] = '\0';	/* Zap the space */
/**/
	return(head);
}
