/*DOSLIB*/
/*UNXLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/*EXTERNAL*/
extern  char    *argvjoin();
extern  char    *getcommand();
extern  char    *argvjoin();
extern	long	time();
extern	int	timeit();
/**/
KENV	kenv;
/**/
hint(ty)
int     ty;
{
static  char    *hx[] = {
"=timeit [command]",
"*       report the time required to execute a simple command or",
"*       shell script.  if no command is specified in the call to",
"*       timeit, it reads the standard input.",
"=EXAMPLES",
"       timeit < script",
"       report on the time required to execute the commands in file",
"       script.",
"       timeit 'lc -l > scratch.tmp'",
"       report on the time required to execute the lc command when",
"       it writes to a temporary file.",
"=",
"~",
"=CAVEATS",
"       highly nested shell scripts may stall with timeit because of",
"       too many processes.",
"       shell blank interpretation and file name expansion must be",
"       considered in using the command line version.",
"=MSDOS VERSION",
"*       reports only on elapsed time.",
"*       use double quotes to preserve blanks in commands.",
"=",
    }   ;
    prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
    return(ty);
}
void
terror(ty)
{
	exit(ty);
}
main(argc,argv)
int     argc;
char    *argv[];
{
	kenv.dosdos = isdos();
	disnme(kenv.pname = "timeit");
	exit(cmdxrc(argc,argv,timeit,"timeit.xrc"));
/* ### Warning timeit.c 57: Function should return a value in function main === */
}
timeit(argc,argv)
int	argc;
char	*argv[];
{
	auto    char    *command;
	auto	long	start = 0L;
	auto	long	stop = 0L;
	auto    double  t0;
	auto    double  t1;
/**/
	if(kenv.dosdos)	cmdxpd(argc,argv);
	else			telluser(kenv.pname);
/**/
/* ### Warning timeit.c 71: Call to function 'hint' with no prototype in function timeit === */
	if(cmdnum(argc,argv,'h',0,DA))	exit(hint(ZERO));
/**/
/* ### Warning timeit.c 73: Call to function 'argvjoin' with no prototype in function timeit === */
	command = argvjoin(argc,argv);
/**/
/* ### Warning timeit.c 75: Call to function 'getcommand' with no prototype in function timeit === */
	if(*command == ZERO)    command = getcommand();
/**/
#ifndef	MSDOS
	t0 = timetotal();
#endif	MSDOS
	time(&start);
	system(command);
#ifndef	MSDOS
	t1 = timetotal();
#endif	MSDOS
	time(&stop);
#ifndef	MSDOS
	if(!kenv.dosdos)
	printf("%6.1f seconds (system and user)\n",t1-t0);
#endif	MSDOS
	printf("%6ld seconds (real)\n",stop-start);
	exit(0);
/* ### Warning timeit.c 92: Function should return a value in function timeit === */
}
#ifdef	MSDOS
double
timetotal()
{
	return(0.0);
}
#endif	MSDOS
char    *
getcommand()
{
	extern  char    *fgetlf();
	static  char    os[BUFSIZ];
	auto    char    *osx = os;
	auto    char    *osu = os + BUFSIZ -1;
	os[0] = ZERO;
	for( ;osx < osu; )  {
	if(isatty(0))   {
		fputs(">> ",stdout);
		fflush(stdout);
		}
	if(!fgetlf(osx,osu,stdin))	break;
	*osx++ = '\n';
	*osx   = ZERO;
	}
	if(isatty(0))   {
		fputs("\n",stdout);
		fflush(stdout);
		}
	if(osx >= osu)  abort();
	return(os);
}
char    *
argvjoin(argc,argv)	/* rejoin arguments */
int     argc;
char    *argv[];
{
	static  char    os[BUFSIZ];
	auto    char    *osx = os;
	auto    char    *osu = os + BUFSIZ - 1;
	auto    int     i;
	os[0] = ZERO;
	for(i = 1; osx < osu && i < argc; i++)  {
		osx = strkat(osx,osu,argv[i]);
		*osx++ = ' ';
		*osx = ZERO;
		}
	if(osx >= osu)  abort();
	return(os);
}

